//
// (Mabel) Mengzi Zhang
// 30 Oct 2010
// CSE 167 hw 5 Scene Graph
//

#ifndef _CURVE_H_
#define _CURVE_H_

// C++
#include <vector>

// Local
#include <Vector3.h>

using namespace std;

class Curve
{
  public:

    Curve ();
    ~Curve () {}

    vector <Vector3 *> * getVerts ();
    vector <int> * getTriIndices ();
    vector <Vector3 *> * getNormals ();
    vector <Vector3 *> * getTexCoords ();
    Vector3 * getCtrlpts ();

    void generate2DCurve (int num_curves, Vector3 * ctrlpts, int num_ctrlpts);
    void evalSamplePts (int num_samplepts);
    void rotateAroundY (float ang_inc, bool fillCaps=false);

    // C1 continuity test
    bool testC1Cont ();
    bool testC1Cont_single (Vector3& p_prev, Vector3& p, Vector3& p_next);

  protected:

    // # curve segments concatenated to form this curve
    int _num_curves;

    // Store an array of ctrl pts for this curve
    Vector3 * _ctrlpts;
    int _num_ctrlpts;

    // Number of sample pts to generate from given ctrl pts
    int _num_samplepts;

    // Angle increment when rotate around y axis
    float _angle_inc;

    float _u_step;

    bool _errExists;


    // Output arrays of pts
    vector <Vector3 *> _verts;
    vector <int> _triIndices;
    vector <Vector3 *> _norms;
    vector <Vector3 *> _texCoords;
    

};

#endif

