#ifndef _CYL_H_
#define _CYL_H_

// Local
#include <shape.h>
#include <Matrix4.h>

class Cyl : public Shape
{
  protected:
    int solid;

    float radius, height;
    bool doTexture;
    float cx, cy, cz;

  public:
    Cyl ();
    Cyl (int s);   // Constructor

    void setCenter (float x, float y, float z);
    void setRadius (float r);
    void setHeight (float h);
    void setTex (bool t);

    void draw ();
    void subdivide (Vector3& v1, Vector3& v2, Vector3& v3, Vector3& v4,
      int depth, int mode);
};

#endif

