//
// (Mabel) Mengzi Zhang
// 12 Nov 2010
// CSE 167 hw 6 Bezier Patch
//

#ifndef _PATCH_H_
#define _PATCH_H_

#include <curve.h>
#include <Vector3.h>
#include <Vector4.h>
#include <Matrix4.h>

class Patch
{
  public:

    Patch ();
    ~Patch () {};

    void generateSurface (Vector3 * ctrlpts, int num_ctrlpts);
    void buildSurface (int num_samplepts);

    vector <Vector3 *> * getVerts ();
    vector <int> * getTriIndices ();
    vector <Vector3 *> * getNormals ();
    vector <Vector3 *> * getTexCoords ();
    Vector3 * getCtrlpts ();


  protected:

    Curve * curve1, * curve2;

    // Store an array of 16 ctrl pts
    Vector3 * _ctrlpts;

    int _num_samplepts;

    vector <Vector3 *> _verts;
    vector <int> _triIndices;
    vector <Vector3 *> _norms;
    vector <Vector3 *> _texCoords;


    bool _errExists;

};

#endif

