//
// (Mabel) Mengzi Zhang
// 30 Oct 2010
// CSE 167 hw 5 Scene Graph
//

#ifndef _PROJECT4_H_
#define _PROJECT4_H_

#include <Matrix4.h>
#include <transformGroup.h>
#include <shape.h>

class ourWindow    // output window related routines
{
  public:
    static int width, height;             // window size
    static Vector3 prev_pt_rot, prev_pt_pan, prev_pt_pan_tball;

    // For view frustum culling
    static float fov, ratio, near, far;
    static Vector3 camPos, camLookat, camUp;


    static void idleCB (void);
    //static void idleCB_video (void);
    static void moveLimb (TransformGroup * limb_tg, const float deg_start,
      const float deg_end, float deg, float& curr_deg,
      Vector3& pivot_offset, Vector3& rot_axis, bool& isFw);

    static void reshapeCB(int, int);
    static void displayCB(void);
    static void keyCB (unsigned char key, int, int);

    // Trackball functionality from hw 2
    // For rotation of object. Used in house and OBJ modes
    static void mouseRotCB (int button, int state, int x, int y);
    static void mouseMotionCB (int x, int y);
    static void saveMouseRot (int curr_x, int curr_y, bool doAction);
    static void calcMouseRot (int curr_x, int curr_y, Vector3& curr_pt);
    static void saveMousePan (int curr_x, int curr_y, bool doAction);
    static void calcMousePan (int curr_x, int curr_y, Vector3& curr_pt);
    static void calcMousePanPsysBillb (int curr_x, int curr_y,
      Vector3& curr_pt);

    // From hw 2
    // Enables change of speed by arrow keys, exit with Esc key
    static void keyboardVelocityCB (int key, int x, int y);

    static void printGLerr ();

    // For view frustum culling
    static void calcFrustumPlanes ();

};

/*
// From hw 2
class ObjFile : public Shape
{
  public:

    ObjFile ();

    void loadObj (Matrix4& transformMat);
    void normalize (float * minmax, Matrix4& transformMat);
    void draw ();

  protected:

    // Vertices
    // v
    int nVerts;
    float * verts;
    // vn
    float * normals;
    // vt
    float * texcoords;
    // f. Index of 3 vertices that make up a triangle
    int nIndices;
    int * indices;
};
*/

int main (int argc, char * argv []);
void usage (char * argv [] = NULL);
void parseArgs (int argc, char * argv []);
void setupCurve (int i, float * ctrlpts_arr);
void loadTex (bool isFirstImg, int w, int h, GLuint& texName,
  unsigned char * texImg);

#endif

