//
// (Mabel) Mengzi Zhang
// 30 Oct 2010
// CSE 167 hw 5 Scene Graph
//

#ifndef _PROJECT4_H_
#define _PROJECT4_H_

#include <Matrix4.h>
#include <cyl.h>

class ourWindow    // output window related routines
{
  public:
    static int width, height;             // window size
    static Vector3 prev_pt;

    // For view frustum culling
    static float fov, ratio, near, far;
    static Vector3 camPos, camLookat, camUp;



    static void idleCB (void);

    static void reshapeCB(int, int);
    static void displayCB(void);
    static void keyCB (unsigned char key, int, int);

    // Trackball functionality from hw 2
    // For rotation of object. Used in house and OBJ modes
    static void mouseRotCB (int button, int state, int x, int y);
    static void mouseMotionRotCB (int x, int y);
    static void calcMouseRot (int curr_x, int curr_y, bool doRot);

    // From hw 2
    // Enables change of speed by arrow keys, exit with Esc key
    static void keyboardVelocityCB (int key, int x, int y);

    static void printGLerr ();
};


int main (int argc, char * argv []);
void usage (char * argv []);
void parseArgs (int argc, char * argv []);

void drawPoint(int x, int y, float r, float g, float b);

#endif

