//
// (Mabel) Mengzi Zhang
// 21 Oct 2010
// CSE 167 hw 4
//

#include <stdio.h>
#include <material.h>

// Init to default all (0 0 0 1)
Material::Material () : Group ()
{
  //GLfloat mat_none_arr [] = {0.0, 0.0, 0.0, 1.0};

  reset ();

  /*
  GLfloat mat_shine_arr [] = {0.0};

  mat_ambient = mat_ambient_arr;
  mat_diffuse = mat_diffuse_arr;
  mat_spec = mat_none_arr;
  mat_emit = mat_none_arr;
  mat_shine = mat_shine_arr;
  */
}

Material::~Material ()
{

}

void Material::reset ()
{
  for (int i = 0; i < 3; i++)
  {
    mat_ambient [i] = 0.0;
    mat_diffuse [i] = 0.0;
    mat_spec [i] = 0.0;
    mat_emit [i] = 0.0;
  }

  mat_ambient [3] = 1.0;
  mat_diffuse [3] = 1.0;
  mat_spec [3] = 1.0;
  mat_emit [3] = 1.0;

  mat_shine = 0.0;
}

// ---------------------------------------------------------------- Getters --

GLfloat * Material::getAmbient () {return mat_ambient;}
GLfloat * Material::getDiffuse () {return mat_diffuse;}
GLfloat * Material::getSpec () {return mat_spec;}
GLfloat Material::getShine () {return mat_shine;}
GLfloat * Material::getEmit () {return mat_emit;}


// ---------------------------------------------------------------- Setters --


void Material::setAmbient (GLfloat v1, GLfloat v2, GLfloat v3, GLfloat v4)
{
  mat_ambient [0] = v1;
  mat_ambient [1] = v2;
  mat_ambient [2] = v3;
  mat_ambient [3] = v4;
}

void Material::setDiffuse (GLfloat v1, GLfloat v2, GLfloat v3, GLfloat v4)
{
  mat_diffuse [0] = v1;
  mat_diffuse [1] = v2;
  mat_diffuse [2] = v3;
  mat_diffuse [3] = v4;
}

void Material::setSpec (GLfloat v1, GLfloat v2, GLfloat v3, GLfloat v4)
{
  mat_spec [0] = v1;
  mat_spec [1] = v2;
  mat_spec [2] = v3;
  mat_spec [3] = v4;
}

void Material::setShine (GLfloat v)
{
  mat_shine = v;
}

void Material::setEmit (GLfloat v1, GLfloat v2, GLfloat v3, GLfloat v4)
{
  mat_emit [0] = v1;
  mat_emit [1] = v2;
  mat_emit [2] = v3;
  mat_emit [3] = v4;
}


// --------------------------------------------------------------- setters --

void Material::setMaterials ()
{
  glMaterialfv (GL_FRONT, GL_AMBIENT, mat_ambient);
  glMaterialfv (GL_FRONT, GL_DIFFUSE, mat_diffuse);
  glMaterialfv (GL_FRONT, GL_SPECULAR, mat_spec);
  glMaterialf (GL_FRONT, GL_SHININESS, mat_shine);
  glMaterialfv (GL_FRONT, GL_EMISSION, mat_emit);

  /*
  fprintf (stderr, "%p %p %p %p %p\n", mat_ambient, mat_diffuse, mat_spec,
    mat_shine, mat_emit);
  fprintf (stderr, "%f %f %f %f\n", mat_ambient[0], mat_ambient[1],
    mat_ambient[2], mat_ambient[3]);
  */
}

void Material::draw (Matrix4& C)
{
  setMaterials ();

  Group::draw (C);
}


void Material::draw_noCull (Matrix4& C)
{
  draw (C);
  Group::draw_noCull (C);
}


