//
// (Mabel) Mengzi Zhang
// 30 Oct 2010
// CSE 167 Final Project
// Museum
//

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

// OpenGL
//#include <glee.h>  // for GLSL shader prgms
#include <shader.h>
#include <GL/glut.h>

// Local
#include <run.h>
#include <Matrix4.h>
#include <material.h>
#include <light.h>
// Scene graph
#include <node.h>
#include <group.h>
#include <leaf.h>
#include <shape3D.h>
//#include <BasicMath.h>
//#include <shader.h>
//#include <cyl.h>
// Culling's objs
//#include <objReader.h>
// Bezier curve
#include <curve.h>
#include <ppmfile.h>
#include <patch.h>
// hw 7
#include "lsys.h"
#include "partsys.h"

#include <assert.h>
#include "tga1.h"        /* simple TGA image file loader */

using namespace std;


/* In case your <GL/gl.h> does not advertise EXT_texture_lod_bias... */
#ifndef GL_EXT_texture_lod_bias
# define GL_MAX_TEXTURE_LOD_BIAS_EXT         0x84fd
# define GL_TEXTURE_FILTER_CONTROL_EXT       0x8500
# define GL_TEXTURE_LOD_BIAS_EXT             0x8501
#endif

/* In case your <GL/gl.h> does not advertise EXT_texture_cube_map... */
#ifndef GL_EXT_texture_cube_map
# define GL_NORMAL_MAP_EXT                   0x8511
# define GL_REFLECTION_MAP_EXT               0x8512
# define GL_TEXTURE_CUBE_MAP_EXT             0x8513
# define GL_TEXTURE_BINDING_CUBE_MAP_EXT     0x8514
# define GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT  0x8515
# define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT  0x8516
# define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT  0x8517
# define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT  0x8518
# define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT  0x8519
# define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT  0x851A
# define GL_PROXY_TEXTURE_CUBE_MAP_EXT       0x851B
# define GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT    0x851C
#endif


int ourWindow::width  = 512;   // set window width in pixels here
int ourWindow::height = 512;   // set window height in pixels here

// For trackball
Vector3 ourWindow::prev_pt_rot = Vector3 ();
static float ter_velo = 1.0f;
static Matrix4 trackball_rotmat = Matrix4 ();

// hw 5
static const int PART_SCENEGRAPH = 1;
static const int PART_CULL = 2;
static const int PART_LIGHT = 3;
// hw 6
static const int PART_CURVE = 4;
static const int PART_SCENE = 5;
static const int PART_PATCH = 6;
// hw 7
static const int PART_MUSEUM = 7;
static int _part = PART_MUSEUM;

// hw4 code
/*
// Part 3
static PpmFile _ppmFile1 = PpmFile ();
static Cyl cyl1 = Cyl ();
int img_w = 0, img_h = 0;
unsigned char * texImg;
static GLuint texName;
static float frame_num = 1;
static int NUM_FRMS_TTL = 12;
*/


// ------------------------------------------------------------------- hw 5 --

// Part 1
static Matrix4 sphere1mat, sphere2mat;
static Light light;
static bool light1_on = true, light2_on = false;
static bool robotIsInited = false;
// scene graph nodes
static TransformGroup * _world_tg, * _robot_tg,
  * _torso_tg, * _headgrp_tg, * _head_tg, * _hat_tg,
  * _armL_tg, * _armR_tg, * _armLU_tg, * _armLL_tg, * _armRU_tg,
  * _armRL_tg, * _handL_tg, * _handR_tg,
  * _legLLgrp_tg, * _legRLgrp_tg,
  * _legL_tg, * _legR_tg, * _legLU_tg, * _legLL_tg, * _legRU_tg,
  * _legRL_tg, * _footL_tg, * _footR_tg;
static Shape3D * _torso, * _head, * _hat,
  * _armLU, * _armLL, * _armRU, * _armRL, * _handL, * _handR,
  * _legLU, * _legLL, * _legRU, * _legRL,
  * _footL, * _footR;

// For robot animation
// arm left
// is moving foward
bool _curr_armLU_isFw = true, _curr_armLL_isFw = true;
// upper
float armULen = 5.0;
float deg_armU_start = -45.0f, deg_armU_end = 45.0f, _curr_deg_armLU = 0.0;
// lower
float armLLen = 4.0;
float deg_armL_start = -60, deg_armL_end = 0, _curr_deg_armLL = 0.0;

// arm right
// is moving foward
bool _curr_armRU_isFw = false, _curr_armRL_isFw = false;
float _curr_deg_armRU = 0.0;  // upper
float _curr_deg_armRL = 0.0;  // lower

// leg left
// is moving forward
bool _curr_legLU_isFw = false, _curr_legLL_isFw = false;
// upper
float torsoHt = 6.0, legULen = 6.0;
float deg_legU_start = -30.0f, deg_legU_end = 30.0f, _curr_deg_legLU = 0.0f;
// lower
float legLLen = 5.0;
float deg_legL_start = 0.0f, deg_legL_end = 60.0f, _curr_deg_legLL = 0.0f;

// leg right
// is moving forward
bool _curr_legRU_isFw = true, _curr_legRL_isFw = true;
float _curr_deg_legRU = 0.0;  // upper
float _curr_deg_legRL = 0.0;  // lower

// foot
float deg_foot_start = -30.0f, deg_foot_end = 30.0f;
// left
bool _curr_footL_isFw = false;
float _curr_deg_footL = 0.0f;
// right
bool _curr_footR_isFw = true;
float _curr_deg_footR = 0.0f;


// Part 2 : View Frustum Culling
float ourWindow::fov = 60.0f, ourWindow::ratio = 1.0f,
  ourWindow::near = 20.0f,//10.0f,
  ourWindow::far = 1000.0f;//1000.0f;
Vector3 ourWindow::camPos = Vector3 (0.0, 0.0, 10.0),
  ourWindow::camLookat = Vector3 (),
  ourWindow::camUp = Vector3 (0.0, 1.0, 0.0);
// for reading obj file
//char objFilename [PATH_MAX];
//static ObjFile objFile1 = ObjFile ();
//static TransformGroup * _teapot_tg;
const static int NUM_OBJS = 100;//400;
static TransformGroup * _teapots_tg [NUM_OBJS];
static Shape3D * _teapot;

// For FPS measurement
static bool cullIsOn = true;
long _start_time = 0, _end_time = 0;
int _num_frames = 0;


// Part 3: Light & Camera
static TransformGroup * _flashlight_tg, * _ground_tg, * _flashlightObj_tg;
static Light * _flashlight;
static Shape3D * _ground, * _flashlightObj;



// Debug flag
static bool CULL_DEBUG = false;


// ------------------------------------------------------------------- hw 6 --

// To add a new bezier curve obj:
// 1. define pts in ctrlpts_arr#
// 2. define ppm file name of texture, then add a else-if statement in loop
//    that calls setupCurve, passing in ctrlpts_arr#
// 3. create TransformGroup * obj, init it in main(), add to a group e.g.
//    _world_tg. Add the new _shape[#] to the new _tg obj. Translate as needed.
// 4. increment NUM_BEZ_OBJS by 1, add an elt to _num_curves [] and
//    _num_ctrlpts [] arrays for the new obj's # bezier segments and # ctrl
//    pts ttl.

// Part 1: Bezier curve surface of revolution around y-axis
static bool _textureOn = true;
static float _OBJS_SCALE = 512.0;

static const int NUM_BEZ_OBJS = 9;

// array must be this size
const static int _num_curves [] = {7, 4, 6, 5, 5, 9, 5, 5, 3};
const static int _num_ctrlpts [] = {22, 13, 19, 16, 16, 28, 16, 16, 10};
const static float _angle_inc [] = {45.0, 45.0, 45.0, 45.0, 45.0, 45.0, 45.0,
  22.5, 90.0};
static Vector3 * _ctrlpts [NUM_BEZ_OBJS];

// An array of pointers to vectors of Vector3 pointers
static vector <Vector3 *> * _verts [NUM_BEZ_OBJS], * _norms [NUM_BEZ_OBJS],
  * _texCoords [NUM_BEZ_OBJS];
static vector <int> * _triIndices [NUM_BEZ_OBJS];

static float * _verts_arr [NUM_BEZ_OBJS], * _norms_arr [NUM_BEZ_OBJS],
  * _texCoords_arr [NUM_BEZ_OBJS];
static int * _triIndices_arr [NUM_BEZ_OBJS];

int _verts_size [NUM_BEZ_OBJS], _triIndices_size [NUM_BEZ_OBJS];

// Bezier objs
static Curve _curve [NUM_BEZ_OBJS];
static Shape _shape [NUM_BEZ_OBJS];
static Material _material [NUM_BEZ_OBJS];
// texture
unsigned char * _texImg [NUM_BEZ_OBJS];
static GLuint _texName [NUM_BEZ_OBJS];
PpmFile _ppmFile [NUM_BEZ_OBJS];
static int _img_w [NUM_BEZ_OBJS], _img_h [NUM_BEZ_OBJS];


// Part 2: Demo Scene
static TransformGroup * _tablegrp_tg, * _table_tg, * _vase_tg,
  * _bowl_tg, * _flowervase_tg, * _rose_tg, * _branch_tg, * _stem1_tg,
  * _stem2_tg, * _scroll_tg;


// Part 3: Patch flag
static Patch _flag = Patch ();
static vector <Vector3 *> * _flag_verts;
static vector <int> * _flag_triIndices;
static int _flag_verts_size, _flag_triIndices_size;
static float * _flag_verts_arr;
static int * _flag_triIndices_arr;
// texture
static GLuint _flag_texName;
static Shape _flag_shape;
static int _flag_img_w, _flag_img_h;
static PpmFile _flag_ppmFile;
unsigned char * _flag_texImg;
static Material _flag_material;



// ------------------------------------------------------------------- hw 7 --

// shader
static Shader* toon;
static int shader_on = -1;

// room
static Shape3D * _room;
static TransformGroup * _room_tg;
static Material * _room_matr;
// room texture
static GLuint _room_texName;
static PpmFile _room_ppmFile;
unsigned char* _room_texImg;
static int _room_tex_imgW, _room_tex_imgH;
static int _room_tex_verts_size, _room_tex_triIndices_size;
static float * _room_tex_verts_arr, * _room_tex_norms_arr,
  * _room_texCoords_arr;
static int * _room_tex_triIndices_arr;
static float _room_tex_solidColor [] = {0.0, 1.0, 1.0};

// background
static Shape3D * _bg, * _grd;
static TransformGroup * _bg_tg, * _grd_tg;
static Material * _bg_matr, * _grd_matr;
// background texture
static GLuint _bg_texName, _grd_texName;
static PpmFile _bg_ppmFile, _grd_ppmFile;
unsigned char * _bg_texImg, * _grd_texImg;
static int _bg_tex_imgW, _bg_tex_imgH, _grd_tex_imgW, _grd_tex_imgH;
static int _bg_tex_verts_size, _bg_tex_triIndices_size,
  _grd_tex_verts_size, _grd_tex_triIndices_size;
static float * _bg_tex_verts_arr, * _bg_tex_norms_arr, * _bg_texCoords_arr,
  * _grd_tex_verts_arr, * _grd_tex_norms_arr, * _grd_texCoords_arr;
static int * _bg_tex_triIndices_arr, * _grd_tex_triIndices_arr;

// map1
static Shape3D * _map1;
static TransformGroup * _map1_tg;
static Material * _map1_matr;
// map1 texture
static GLuint _map1_texName;
static PpmFile _map1_ppmFile;
unsigned char* _map1_texImg;
static int _map1_tex_imgW, _map1_tex_imgH;
static int _map1_tex_verts_size, _map1_tex_triIndices_size;
static float * _map1_tex_verts_arr, * _map1_tex_norms_arr,* _map1_texCoords_arr;
static int * _map1_tex_triIndices_arr;
static float _map1_tex_solidColor [] = {0.0, 1.0, 1.0};

// map2
static Shape3D * _map2;
static TransformGroup * _map2_tg;
static Material * _map2_matr;
// map2 texture
static GLuint _map2_texName;
static PpmFile _map2_ppmFile;
unsigned char* _map2_texImg;
static int _map2_tex_imgW, _map2_tex_imgH;
static int _map2_tex_verts_size, _map2_tex_triIndices_size;
static float * _map2_tex_verts_arr, * _map2_tex_norms_arr,* _map2_texCoords_arr;
static int * _map2_tex_triIndices_arr;
static float _map2_tex_solidColor [] = {0.0, 1.0, 1.0};

// map3
static Shape3D * _map3;
static TransformGroup * _map3_tg;
static Material * _map3_matr;
// map3 texture
static GLuint _map3_texName;
static PpmFile _map3_ppmFile;
unsigned char* _map3_texImg;
static int _map3_tex_imgW, _map3_tex_imgH;
static int _map3_tex_verts_size, _map3_tex_triIndices_size;
static float * _map3_tex_verts_arr, * _map3_tex_norms_arr,* _map3_texCoords_arr;
static int * _map3_tex_triIndices_arr;
static float _map3_tex_solidColor [] = {0.0, 1.0, 1.0};

// map4
static Shape3D * _map4;
static TransformGroup * _map4_tg;
static Material * _map4_matr;
// map4 texture
static GLuint _map4_texName;
static PpmFile _map4_ppmFile;
unsigned char* _map4_texImg;
static int _map4_tex_imgW, _map4_tex_imgH;
static int _map4_tex_verts_size, _map4_tex_triIndices_size;
static float * _map4_tex_verts_arr, * _map4_tex_norms_arr,* _map4_texCoords_arr;
static int * _map4_tex_triIndices_arr;
static float _map4_tex_solidColor [] = {0.0, 1.0, 1.0};

//ceiling
static Shape3D * _cieling;
static TransformGroup * _cieling_tg;
static Material * _cieling_matr;
// ceiling texture
static GLuint _cieling_texName;
static PpmFile _cieling_ppmFile;
unsigned char* _cieling_texImg;
static int _cieling_tex_imgW, _cieling_tex_imgH;
static float _cieling_tex_solidColor [] = {0.0, 1.0, 1.0};

//floor
static Shape3D * _floor;
static TransformGroup * _floor_tg;
static Material * _floor_matr;
// floor texture
static GLuint _floor_texName;
static PpmFile _floor_ppmFile;
unsigned char* _floor_texImg;
static int _floor_tex_imgW, _floor_tex_imgH;
static float _floor_tex_solidColor [] = {0.0, 1.0, 1.0};

//fractal tree1
static Shape3D * _fract_tree1;
static TransformGroup * _fract_tree1_tg, * _fract_tree2_tg, * _fract_tree3_tg;
static Material * _fract_tree1_matr, * _fract_tree2_matr, * _fract_tree3_matr;

// fractal tree1 texture
static GLuint _fract_tree1_texName;
static PpmFile _fract_tree1_ppmFile;
unsigned char* _fract_tree1_texImg;
static int _fract_tree1_tex_imgW, _fract_tree1_tex_imgH;
static float _fract_tree1_tex_solidColor [] = {0.0, 1.0, 1.0};

// glass
static Shape3D * _glass1;
static TransformGroup * _glass1_tg;
static Material * _glass1_matr;
// glass opening interaction
static float _glass1_openLimitZ = -200.0f, _glass1_openIncZ = -5.0,
  _glass1_openCurrZ = 0.0f;
static bool _glass1_openOn = false;


// user movement
Vector3 ourWindow::prev_pt_pan = Vector3 ();
static Matrix4 _user_mov_mat = Matrix4 ();

static bool _mouse_left_down = false, _mouse_right_down = false;

// L System
LSys * _lsys1;
static int lsysNumRecur = 0;
static TransformGroup * _lsys1_tg, * _lsys2_tg;
// To store user input for # recursions
// Assumption: number of recursions won't exceed 10 digit number (1 extra
//   char to store the null char '\0')
static char lsysNumRecurStr [11];
// To accept each keystroke input from user
static char lsysNumRecurChr [2];
static int lsysAcceptInput = -1;

// L System materials
Material * _lsys1_matr, * _lsys2_matr;

// Single obj files
char objFilename [PATH_MAX];
// Globe, balance, old Galeon ship, Greek ancient ship
static Shape3D  * _globe, 
                * _balance, 
                * _ship_greek, * _ship_greekSail,
                * _ship_galeon, 
                * _ship_glorieux, * _ship_realedefr, * _ship_realedefrSail,
  * _ship_chess,
                * _ship_roman, * _ship_tallClipper, * _ship_tallClipperSail,
                * _table1,
                * _ship_sanjuan, * _ship_sanjuanSail;

static TransformGroup   * _globe_tg, 
                        * _balance_tg, 
  * _ship_greek_tg, * _ship_greekSail_tg,
                        * _ship_galeon_tg,
                        * _ship_glorieux_tg,
                        * _ship_realedefr_tg, * _ship_realedefrSail_tg,
                        * _ship_chess_tg,
                        * _ship_roman_tg,
  * _ship_tallClipper_tg, * _ship_tallClipperSail_tg,
  * _table1_tg,
  * _ship_sanjuan_tg, * _ship_sanjuanSail_tg;

static Material     * _globe_matr, * _balance_matr,
  * _ship_greek_matr, * _ship_greekSail_matr,
                    * _ship_galeon_matr,
                    * _ship_glorieux_matr,
                    * _ship_realedefr_matr, * _ship_realedefrSail_matr,
                    * _ship_chess_matr,
                    * _ship_roman_matr,
  * _ship_tallClipper_matr, * _ship_tallClipperSail_matr,
  * _table1_matr,
  * _ship_sanjuan_matr, * _ship_sanjuanSail_matr;

// Dividing chains
static Shape3D * _chain1;
static TransformGroup * _chain1_tg;
static Material * _chain1_matr;

// Particle system
PartSys * _psys1;
static TransformGroup * _psys1_tg, * _psys2_tg, * _psys3_tg;
static int psysAcceptInput = -1;
Material * _psys1_matr;

//Objects with environment mapping
//david
static Shape3D * _david;
static TransformGroup * _david_tg;
static Material * _david_matr;

// materials on ships
static GLuint _ship_galeon_texName;
static PpmFile _ship_galeon_ppmFile;
unsigned char* _ship_galeon_texImg;
static int _ship_galeon_tex_imgW, _ship_galeon_tex_imgH;
static int _ship_galeon_tex_verts_size, _ship_galeon_tex_triIndices_size;
static float * _ship_galeon_tex_verts_arr, * _ship_galeon_tex_norms_arr,
  * _ship_galeon_texCoords_arr;
static int * _ship_galeon_tex_triIndices_arr;
static float _ship_galeon_tex_solidColor [] = {0.0, 1.0, 1.0};

// Particle system billboard
Vector3 ourWindow::prev_pt_pan_tball = Vector3 ();


/*static GLenum faceTarget[6] = {
  GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT
};*/

/* Pre-generated cube map images. */
char *faceFile1[6] = {
  "in/globeLeft.tga", 
  "in/globeRight.tga", 
  "in/globeTop.tga", 
  "in/globeBottom.tga", 
  "in/globeBack.tga", 
  "in/globeFront.tga", 
};
/*char *faceFile1[6] = {
  "in/Golden_Texture.tga", 
  "in/Golden_Texture.tga", 
  "in/Golden_Texture.tga", 
  "in/Golden_Texture.tga", 
  "in/Golden_Texture.tga", 
  "in/Golden_Texture.tga", 
};*/
/* Pre-generated cube map images. */
char *faceFile2[6] = {
  "in/sculpLeft.tga", 
  "in/sculpRight.tga", 
  "in/sculpTop.tga", 
  "in/sculpBottom.tga", 
  "in/sculpBack.tga", 
  "in/sculpFront.tga",  
};


//GL_REFLECTION_MAP_EXT or GL_NORMAL_MAP_EXT
int mode = GL_REFLECTION_MAP_EXT;
//GL_CLAMP or GL_REPEAT
int wrap = GL_REPEAT;
int mipmaps = 0;
double lodBias;

/*void
loadFace(GLenum target, char *filename)
{
  FILE *file;
  gliGenericImage *image;

  file = fopen(filename, "rb");
  if (file == NULL) 
  {
    printf("cm_demo: could not open \"%s\"\n", filename);
    //exit(1);
  }

  image = gliReadTGA(file, filename);
  fclose(file);

  if (mipmaps) 
  {
    gluBuild2DMipmaps(target, image->components,
      image->width, image->height,
      image->format, GL_UNSIGNED_BYTE, image->pixels);
  } 
  else 
  {
    glTexImage2D(target, 0, image->components,
      image->width, image->height, 0,
      image->format, GL_UNSIGNED_BYTE, image->pixels);
  }
}

void
updateTexgen(void)
{
  assert(mode == GL_NORMAL_MAP_EXT || mode == GL_REFLECTION_MAP_EXT);
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, mode);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, mode);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, mode);
}

void
updateWrap(void)
{
  glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_WRAP_S, wrap);
  glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_WRAP_T, wrap);
}

void
makeCubeMap(void)
{
  int i;

  for (i=0; i<6; i++) 
  {
    loadFace(faceTarget[i], faceFile[i]);
  }
  if (mipmaps) 
  {
    glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_MIN_FILTER,
      GL_LINEAR_MIPMAP_LINEAR);
    glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  } 
  else 
  {
    glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  }
  //glEnable(GL_TEXTURE_CUBE_MAP_EXT);

  updateTexgen();
  updateWrap();

  //glEnable(GL_TEXTURE_GEN_S);
  //glEnable(GL_TEXTURE_GEN_T);
  //glEnable(GL_TEXTURE_GEN_R);
}*/


// ---------------------------------------------------------------------------

int main(int argc, char * argv [])
{

  parseArgs (argc, argv);
  //usage (argv);


  glutInit(&argc, argv);      	      	      // initialize GLUT
  // open an OpenGL context with double buffering, RGB colors, and depth
  //   buffering
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  // set initial window size
  glutInitWindowSize(ourWindow::width, ourWindow::height);
  // open window and set window title
  glutCreateWindow("Mabel's Playground");
  // this just maximizes window
  //glutFullScreen ();
  // real full screen mode
  //glutGameModeString ("640x480:16@60");
  //glutGameModeString ("800x600:16@60");
  //glutEnterGameMode ();

  glEnable(GL_DEPTH_TEST);            	      // enable depth buffering
  glClearColor(0.0, 0.0, 0.0, 0.0);   	      // set clear color to black
  // clear depth buffer
  glClear (GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_PROJECTION); 

  _world_tg = new TransformGroup ();
  _world_tg -> setName ("worldMat");


  // Scene graph data structure
  if ((_part == PART_SCENEGRAPH) || (_part == PART_LIGHT))
  {
    _robot_tg = new TransformGroup ();
    _robot_tg -> setName ("robotMat");

    // Allocate on heap so that temp var returned from ctor doesn't go out of
    //   scope (if on stack, would go out of scope)
    _torso_tg = new TransformGroup ();
    _torso_tg -> setName ("torsoMat");
    _headgrp_tg = new TransformGroup ();
    _headgrp_tg -> setName ("headGroupMat");
    _head_tg = new TransformGroup ();
    _head_tg -> setName ("headMat");
    _hat_tg = new TransformGroup ();
    _hat_tg -> setName ("hatMat");

    _armL_tg = new TransformGroup (); 
    _armL_tg -> setName ("armLeftMat");
    _armR_tg = new TransformGroup ();
    _armR_tg -> setName ("armRightMat"); 
    _armLU_tg = new TransformGroup ();
    _armLU_tg -> setName ("armLeftUpperMat"); 
    _armLL_tg = new TransformGroup ();
    _armLL_tg -> setName ("armLeftLowerMat");
    _armRU_tg = new TransformGroup ();
    _armRU_tg -> setName ("armRightUpperMat");
    _armRL_tg = new TransformGroup ();
    _armRL_tg -> setName ("armRightLowerMat");

    _handL_tg = new TransformGroup ();
    _handL_tg -> setName ("handLeftMat");
    _handR_tg = new TransformGroup ();
    _handR_tg -> setName ("handRightMat");

    _legLLgrp_tg = new TransformGroup ();
    _legLLgrp_tg -> setName ("legLeftLowerGroupMat");
    _legRLgrp_tg = new TransformGroup ();
    _legRLgrp_tg -> setName ("legRightLowerGroupMat");

    _legL_tg = new TransformGroup (); 
    _legL_tg -> setName ("legLeftMat");
    _legR_tg = new TransformGroup (); 
    _legR_tg -> setName ("legRightMat");
    _legLU_tg = new TransformGroup (); 
    _legLU_tg -> setName ("legLeftUpperMat");
    _legLL_tg = new TransformGroup ();
    _legLL_tg -> setName ("legLeftLowerMat");
    _legRU_tg = new TransformGroup (); 
    _legRU_tg -> setName ("legRightUpperMat");
    _legRL_tg = new TransformGroup (); 
    _legRL_tg -> setName ("legRightLowerMat");

    _footL_tg = new TransformGroup ();
    _footL_tg -> setName ("footLeftMat");
    _footR_tg = new TransformGroup ();
    _footR_tg -> setName ("footRightMat");


    // Instantita geometry Shape3D

    _torso = new Shape3D (SHAPE_CUBE);
    _torso -> setName ("torso");
    _head = new Shape3D (SHAPE_SPHERE);
    _head -> setName ("head");
    _hat = new Shape3D (SHAPE_CONE);
    _hat -> setName ("hat");

    _armLU = new Shape3D (SHAPE_CUBE);
    _armLU -> setName ("armLeftUpper");
    _armLL = new Shape3D (SHAPE_CUBE);
    _armLL -> setName ("armLeftLower");
    _armRU = new Shape3D (SHAPE_CUBE);
    _armRU -> setName ("armRightUpper");
    _armRL = new Shape3D (SHAPE_CUBE);
    _armRL -> setName ("armRightLower");

    _handL = new Shape3D (SHAPE_SPHERE);
    _handL -> setName ("handLeft");
    _handR = new Shape3D (SHAPE_SPHERE);
    _handR -> setName ("handRight");

    _legLU = new Shape3D (SHAPE_CUBE);
    _legLU -> setName ("legLeftUpper");
    _legLL = new Shape3D (SHAPE_CUBE);
    _legLL -> setName ("legLeftLower");
    _legRU = new Shape3D (SHAPE_CUBE);
    _legRU -> setName ("legRightUpper");
    _legRL = new Shape3D (SHAPE_CUBE);
    _legRL -> setName ("legRightLower");

    _footL = new Shape3D (SHAPE_CUBE);
    _footL -> setName ("handLeft");
    _footR = new Shape3D (SHAPE_CUBE);
    _footR -> setName ("handRight");

    // For flashlight part, add flashlight obj
    if (_part == PART_LIGHT)
    {
      _flashlight_tg = new TransformGroup ();
      _flashlight_tg -> setName ("flashlightTG");

      _flashlightObj_tg = new TransformGroup ();
      _flashlightObj_tg -> setName ("flashlightObjTG");

      _ground_tg = new TransformGroup ();
      _ground_tg -> setName ("groundTG");

      _flashlight = new Light ();
      _flashlight -> setName ("flashlight");

      _flashlightObj = new Shape3D (SHAPE_CONE);
      _flashlightObj -> setName ("flashlightObj");

      _ground = new Shape3D (SHAPE_CUBE);
      _ground -> setName ("ground");
    }


    // Set up hierarchy relationship

    _world_tg -> addChild (_robot_tg);

    _robot_tg -> addChild (_torso_tg);
    _robot_tg -> addChild (_headgrp_tg);
    _robot_tg -> addChild (_armL_tg);
    _robot_tg -> addChild (_armR_tg);
    _robot_tg -> addChild (_legL_tg);
    _robot_tg -> addChild (_legR_tg);

    _torso_tg -> addChild (_torso);
    _headgrp_tg -> addChild (_head_tg);
    _headgrp_tg -> addChild (_hat_tg);
    _head_tg -> addChild (_head);
    _hat_tg -> addChild (_hat);

    _armL_tg -> addChild (_armLU_tg);
    _armL_tg -> addChild (_armLL_tg);
    _armLL_tg -> addChild (_handL_tg);
    _armR_tg -> addChild (_armRU_tg);
    _armR_tg -> addChild (_armRL_tg);
    _armRL_tg -> addChild (_handR_tg);
    _legL_tg -> addChild (_legLU_tg);
    _legL_tg -> addChild (_legLLgrp_tg);
    _legLLgrp_tg -> addChild (_legLL_tg);
    _legLLgrp_tg -> addChild (_footL_tg);
    _legR_tg -> addChild (_legRU_tg);
    _legR_tg -> addChild (_legRLgrp_tg);
    _legRLgrp_tg -> addChild (_legRL_tg);
    _legRLgrp_tg -> addChild (_footR_tg);

    // Add geometry shapes to TransformGroups
    _armLU_tg -> addChild (_armLU);
    _armLL_tg -> addChild (_armLL);
    _armRU_tg -> addChild (_armRU);
    _armRL_tg -> addChild (_armRL);
    _handL_tg -> addChild (_handL);
    _handR_tg -> addChild (_handR);
    _legLU_tg -> addChild (_legLU);
    _legLL_tg -> addChild (_legLL);
    _legRU_tg -> addChild (_legRU);
    _legRL_tg -> addChild (_legRL);
    _footL_tg -> addChild (_footL);
    _footR_tg -> addChild (_footR);

    // For flashlight part, add flashlight into hand
    if (_part == PART_LIGHT)
    {
      _world_tg -> addChild (_ground_tg);
      _ground_tg -> addChild (_ground);

      _handL_tg -> addChild (_flashlight_tg);
      _flashlight_tg -> addChild (_flashlight);

      _handL_tg -> addChild (_flashlightObj_tg);
      _flashlightObj_tg -> addChild (_flashlightObj);
    }


    // Set up transformation of each piece

    // To store temp transforms
    Matrix4 transf = Matrix4 ();
    // To store current target mat
    Matrix4 * curr_mat;

    // root of robot
    // translate so can rotate easily to walk in circle
    curr_mat = _robot_tg -> getMat ();
    transf.translate (-6,0,0);
    transf.mul (*curr_mat, *curr_mat);

    // Scale torso cube to make rectangular solid
    curr_mat = _torso_tg -> getMat ();
    transf.scale (3,torsoHt,2);
    transf.mul (*curr_mat, *curr_mat);

    // head & hat

    // Move head group up from torso
    curr_mat = _headgrp_tg -> getMat ();
    transf.translate (0, 5, 0);
    transf.mul (*curr_mat, *curr_mat);

    _head -> setRadius (1.5);
    _head -> setWireframe (true);

    // Scale hat, move hat up from head
    curr_mat = _hat_tg -> getMat ();
    transf.rotateX (90);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate (0, 1.5, 0);
    transf.mul (*curr_mat, *curr_mat);
    _hat -> setRadius (1.5);
    _hat -> setHeight (2);
    _hat -> setWireframe (true);

    // left arm

    // Translate armLeft to left of torso
    curr_mat = _armL_tg -> getMat ();
    transf.translate (-2.5, 0.5, 0);
    transf.mul (*curr_mat, *curr_mat);

    // Scale armLeftUpper to right size of arm
    curr_mat = _armLU_tg -> getMat ();
    transf.scale (1,armULen,1);
    transf.mul (*curr_mat, *curr_mat);

    // Scale armLeftLower to arm size, translate to below from upper arm
    curr_mat = _armLL_tg -> getMat ();
    transf.scale (1,armLLen,1);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate (0, -5, 0);
    transf.mul (*curr_mat, *curr_mat);

    // Move hand down from upper arm
    // Undo lower arm's scale by dividing armLLen, then scale the hand itself
    //   by multiplying the factor, now 0.75
    curr_mat = _handL_tg -> getMat ();
    transf.scale (0.75,0.75/armLLen,0.75);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate (0,-0.75,0);
    transf.mul (*curr_mat, *curr_mat);
    _handL -> setWireframe (true);

    // right arm

    // Scale armRight
    curr_mat = _armR_tg -> getMat ();
    transf.translate (2.5, 0.5, 0);
    transf.mul (*curr_mat, *curr_mat);

    // Scale armRightUpper to right size of arm
    curr_mat = _armRU_tg -> getMat ();
    transf.scale (1,armULen,1);
    transf.mul (*curr_mat, *curr_mat);

    // Scale armRightLower to arm size, translate to below from upper arm
    curr_mat = _armRL_tg -> getMat ();
    transf.scale (1,armLLen,1);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate (0, -5, 0);
    transf.mul (*curr_mat, *curr_mat);

    // Move hand down from upper arm
    curr_mat = _handR_tg -> getMat ();
    transf.scale (0.75,0.75/armLLen,0.75);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate (0,-0.75,0);
    transf.mul (*curr_mat, *curr_mat);
    _handR -> setWireframe (true);

    // left leg

    // Translate legLeft to left of torso
    curr_mat = _legL_tg -> getMat ();
    transf.translate (-1, -6.5, 0);
    transf.mul (*curr_mat, *curr_mat);

    // Scale legLeftUpper to right size of arm
    curr_mat = _legLU_tg -> getMat ();
    transf.scale (1.2,legULen,1.2);
    transf.mul (*curr_mat, *curr_mat);

    // Translate legLeftLowerGrp below upper leg
    curr_mat = _legLLgrp_tg -> getMat ();
    transf.translate (0, -6, 0);
    transf.mul (*curr_mat, *curr_mat);

    // Scale legLeftLower to arm size
    curr_mat = _legLL_tg -> getMat ();
    transf.scale (1.2,legLLen,1.2);
    transf.mul (*curr_mat, *curr_mat);

    // Move foot down from upper leg
    curr_mat = _footL_tg -> getMat ();
    transf.scale (1.2,0.2,3);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate (0, -legLLen/2, 1);
    transf.mul (*curr_mat, *curr_mat);

    // right leg

    // Translate legLeft to left of torso
    curr_mat = _legR_tg -> getMat ();
    transf.translate (1, -6.5, 0);
    transf.mul (*curr_mat, *curr_mat);

    // Scale legLeftUpper to right size of arm
    curr_mat = _legRU_tg -> getMat ();
    transf.scale (1.2,legULen,1.2);
    transf.mul (*curr_mat, *curr_mat);

    // Translate legRightLowerGrp below upper arm
    curr_mat = _legRLgrp_tg -> getMat ();
    transf.translate (0, -6, 0);
    transf.mul (*curr_mat, *curr_mat);

    // Scale legRightLower to arm size
    curr_mat = _legRL_tg -> getMat ();
    transf.scale (1.2,legLLen,1.2);
    transf.mul (*curr_mat, *curr_mat);

    // Move foot down from upper leg
    curr_mat = _footR_tg -> getMat ();
    transf.scale (1.2,0.2,3);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate (0,-legLLen/2,1);
    transf.mul (*curr_mat, *curr_mat);


    // For flashlight part, add flashlight transformation
    if (_part == PART_LIGHT)
    {
      // light shouldn't need transforms? `.` it's under hand's matrix, which
      //   should have the transform already?

      // set up light properties
      curr_mat = _flashlight_tg -> getMat ();
      transf.translate (0,0,-2);
      transf.mul (*curr_mat, *curr_mat);
      transf.rotate (-1,0,0,90);
      transf.mul (*curr_mat, *curr_mat);
      _flashlight -> setLitNum (GL_LIGHT1);
      _flashlight -> setAmbient (0.0, 0.0, 1.0, 1.0);
      _flashlight -> setDiffuse (0.0, 1.0, 1.0, 1.0);
      _flashlight -> setSpec (0.0, 1.0, 1.0, 1.0);
      _flashlight -> setPos (0.0, 0.0, 0.0, 1.0);
      //_flashlight -> setSpotDir (0.5, -0.5, 0.0);  // partially working
      _flashlight -> setSpotDir (0.8, -0.3, 0.0);  // partially working
      //_flashlight -> setSpotDir (0.3, 0.0, -0.8);
      //_flashlight -> setSpotDir (0.0, 0.8, 0.0);  // alien-like
      //_flashlight -> setSpotDir (-0.5, 0.2, 0.0);
      //_flashlight -> setSpotDir (0.0, -0.5, -0.5);
      _flashlight -> setSpotCut (60.0);
      //_flashlight -> setAttenConst (0);

      // translate flashlight obj a bit from hand
      curr_mat = _flashlightObj_tg -> getMat ();
      transf.translate (0,0,-2);
      //transf.translate (0,0,2);
      transf.mul (*curr_mat, *curr_mat);
      transf.rotate (-1,0,0,90);
      transf.mul (*curr_mat, *curr_mat);

      // ground
      curr_mat = _ground_tg -> getMat ();
      transf.translate (0,-80,-0.4);
      transf.mul (*curr_mat, *curr_mat);
      transf.scale (120,0.2,100);
      transf.mul (*curr_mat, *curr_mat);
    }


    //fprintf (stderr, "robot initialized\n");
    robotIsInited = true;
  }

  if (_part == PART_CULL)
  {
    /*
    // Init global frustum array for culling
    for (int i = 0; i < 6; i++)
    {
      frus_norms_main [i] = new Vector3 ();
      frus_pts_main [i] = new Vector3 ();
    }
    */

    /*
    // Load objs from .obj file

    *(objFilename) = 0;
    strcat (objFilename, "in/teapot.obj");

    // Load obj file
    Matrix4 transformMat = Matrix4 ();
    // Load obj file, set transformMat to center obj file
    objFile1.loadObj (transformMat);

    objFile1.getMatrix ().identity ();
    objFile1.getMatrix ().mul (transformMat, objFile1.getMatrix ());
    */

    _teapot = new Shape3D (SHAPE_OBJ);
    _teapot -> setName ("in/teapot.obj");

    //_teapot_tg = new TransformGroup ();
    //_teapot_tg -> setName ("teapotTG");

    char tgName [20];
    *tgName = 0;
    int ttl_rows = 20, ttl_cols = 20;
    int curr_row = 0, curr_col = 0;
    float curr_x = -10.0f, curr_z = -10.0f;
    Matrix4 transf = Matrix4 ();
    Matrix4 * curr_mat = NULL;

    // Create 100 TGs and add shape instance child to each one
    for (int i = 0; i < NUM_OBJS; i++)
    {
      _teapots_tg [i] = new TransformGroup ();
      sprintf (tgName, "teapotTG%d", i);
      _teapots_tg [i] -> setName (tgName);

      // Add to root node
      _world_tg -> addChild (_teapots_tg [i]);

      // All TGs share same geometry instance
      _teapots_tg [i] -> addChild (_teapot);


      // Transform teapots' mat so that teapots are arranged in a 2D grid
      transf.identity ();
      transf.translate (curr_x, 0, curr_z);

      curr_mat = _teapots_tg [i] -> getMat ();
      transf.mul (*curr_mat, *curr_mat);


      // Last cell, go to next row
      if (curr_col == ttl_cols-1)
      {
        curr_col = 0;
        curr_row ++;
        curr_x = -10.0f;
        curr_z += obj_cellH;
      }
      // Go to next column
      else
      {
        curr_col ++;
        //curr_row stays same
        curr_x += obj_cellW;
        //curr_z stays same
      }

      //fprintf (stderr, "teapot initialized.\n");
    }

    //_world_tg -> addChild (_teapot_tg);
    //_teapot_tg -> addChild (_teapot);
  }


  if ((_part == PART_CURVE) || (_part == PART_SCENE))
  {
    if (_part == PART_CURVE)
      _OBJS_SCALE = 512.0;
    else if (_part == PART_SCENE)
      _OBJS_SCALE = 512.0;
    else if (_part == PART_PATCH)
      _OBJS_SCALE = 512.0;

    // Define ctrl pts

    // Bezier obj 1: Qing Hua Ci vase
    float ctrlpts_arr1 [] = {
      // inside
      0,-434,  30,-439,  68,-424,  93,-398,  118,-372,  124,-297,  67,-273,
      10,-249,  44,-151,  122,-147,

      // outside
      200,-147,  78,-153,  64,-177,  50,-201,  28,-232,  74,-269,  120,-306,
      173,-331,  136,-372,  99,-413,  88,-438,  0,-447

      // orig vase
      /*
      // inside
      0,-365,  106,-357,  128,-336,  169,-312,  185,-288,  186,-236,
      156,-206,  126,-176,  95,-156,  72,-112,  65,-68,  62,29,

      // outside
      100,38,  77,6,  71,-61,  97,-137,  140,-216,  192,-198,  204,-268,
      203,-329,  159,-367,  0,-386
      */
    };

    // Bezier obj 2: bowl
    float ctrlpts_arr2 [] = {
      // inside
      0,-432,  35,-429,  67,-421,  101,-398,  128,-355,  145,-316,  176,-302,
      // outside
      191,-313,  170,-336,  149,-362,  124,-394,  98,-425,  0,-442
    };

    // Bezier obj 3: stool
    float ctrlpts_arr3 [] = {
      // tabletop
      0,-52,  249,-50,  352,-59,  202,-63,
      // neck
      52,-67,  22,-99,  39,-105,  56,-111,  10,-121,
      // straight leg
      10,-153,  10,-185,  9,-374,
      // base
      9,-427,  9,-480,  60,-493,  83,-497, 106,-501,  84,-509,
      0,-513
    };

    // Bezier obj 4: flower vase
    float ctrlpts_arr4 [] = {
      // inside
      0,-479,  26,-463,  22,-409,  17,-367,  12,-325,  0,-293,  14,-251,
      28,-209,  50,-214,
      // outside
      34,-240,  18,-266,  7,-273,  16,-318,  25,-363,  42,-501,  0,-494
    };

    // Bezier obj 5: rose
    float ctrlpts_arr5 [] = {
      // flower
      0,-106,  10,-86,  32,-77,  28,-85,  24,-93,  48,-89,  35,-104,  22,-119,
      56,-138,  32,-154,
      // stem
      8,-170,  7,-184,  7,-293,  7,-402,  6,-428,  0,-462
    };

    // Bezier obj 6: branches
    float ctrlpts_arr6 [] = {
      // branch 1
      2,-507,  22,-449,  90,-365,  254,-225,  418,-85,  164,-277,  86,-364,
      8,-451,
      // branch 2
      12,-437,  146,-229,  280,-21,  114,-254,  64,-335,  14,-416,
      // branch 3
      0,-400,  37,-286,  74,-172,  102,-144,  120,-118,  138,-92,  142,-71,
      136,-47,  130,-23,  114,-5,  127,-45,  140,-85,  110,-98,  0,-342
    };

    // Bezier obj 7: stem
    float ctrlpts_arr7 [] = {
      0,-24,  4,-41,  3,-72,  9,-83,  15,-94,  5,-97,  4,-119,  3,-141,
      0,-165,  6,-177,  12,-189,  15,-207,  6,-207,  2,-313,  6,-446,  0,-491
    };

    // Bezier obj 8: scroll
    float ctrlpts_arr8 [] = {
      0,-21,  12,-21,  176,-21,  175,-22,  182,-22,  179,-426,  167,-426,
      155,-426,  28,-428,  0,-426
    };

    char ppmFilename [NUM_BEZ_OBJS] [PATH_MAX];
    *(ppmFilename[0]) = 0;
    strcat (ppmFilename[0], "in/0002cut.ppm");
    *(ppmFilename[1]) = 0;
    strcat (ppmFilename[1], "in/0032pl.ppm");
    *(ppmFilename[2]) = 0;
    //strcat (ppmFilename[2], "in/0014.ppm");  // blue stone surface
    strcat (ppmFilename[2], "in/0043.ppm");
    *(ppmFilename[3]) = 0;
    strcat (ppmFilename[3], "in/0035.ppm");
    *(ppmFilename[4]) = 0;
    strcat (ppmFilename[4], "in/0045.ppm");
    *(ppmFilename[5]) = 0;
    strcat (ppmFilename[5], "in/0047.ppm");
    *(ppmFilename[6]) = 0;
    strcat (ppmFilename[6], "in/0047.ppm");
    *(ppmFilename[7]) = 0;
    //strcat (ppmFilename[7], "in/0017.ppm");
    strcat (ppmFilename[7], "in/0010.ppm");
    //strcat (ppmFilename[7], "in/0033.ppm");
    *(ppmFilename[8]) = 0;
    strcat (ppmFilename[8], "in/0053.ppm");


    // Generate solid from curve
    for (int i = 0; i < NUM_BEZ_OBJS; i++)
    {
      _ctrlpts[i] = new Vector3 [_num_ctrlpts [i]];
      _curve [i] = Curve ();
      if (i == 0)
        setupCurve (i, ctrlpts_arr1);
      else if (i == 1)
        setupCurve (i, ctrlpts_arr2);
      else if (i == 2)
        setupCurve (i, ctrlpts_arr3);
      else if (i == 3)
        setupCurve (i, ctrlpts_arr4);
      else if (i == 4)
        setupCurve (i, ctrlpts_arr5);
      else if (i == 5)
        setupCurve (i, ctrlpts_arr6);
      else if (i == 6)
        setupCurve (i, ctrlpts_arr7);
      else if (i == 7)
        setupCurve (i, ctrlpts_arr7);
      else if (i == 8)
        setupCurve (i, ctrlpts_arr8);

      // Texture
      _img_w[i] = 0;
      _img_h[i] = 0;
      _texImg[i] = _ppmFile[i].loadPPM (ppmFilename[i], _img_w[i], _img_h[i]);
      loadTex (true, _img_w[i], _img_h[i], _texName [i], _texImg[i]);

      _shape [i] = Shape ();
      _material[i] = Material ();
    }


    // Set up vase only
    if (_part == PART_CURVE)
    {
      _vase_tg = new TransformGroup ();
      _vase_tg -> setName ("vaseTG");

      _world_tg -> addChild (_vase_tg);
      _vase_tg -> addChild (&_shape [0]);

      // To store temp transforms
      Matrix4 transf = Matrix4 ();
      // To store current target mat
      Matrix4 * curr_mat;

      curr_mat = _vase_tg -> getMat ();
      transf.translate (0, 256.0/512.0, 0.0);
      transf.mul (*curr_mat, *curr_mat);
    }

    // Set up demo scene
    else if (_part == PART_SCENE)
    {
      // Build scene graph structure

      // Init objs

      _tablegrp_tg = new TransformGroup ();
      _tablegrp_tg -> setName ("tablegrpTG");
      _table_tg = new TransformGroup ();
      _table_tg -> setName ("tableTG");
      _vase_tg = new TransformGroup ();
      _vase_tg -> setName ("vaseTG");
      _bowl_tg = new TransformGroup ();
      _bowl_tg -> setName ("bowlTG");
      _flowervase_tg = new TransformGroup ();
      _flowervase_tg -> setName ("flowervaseTG");
      _rose_tg = new TransformGroup ();
      _rose_tg -> setName ("roseTG");
      _branch_tg = new TransformGroup ();
      _branch_tg -> setName ("branchTG");
      _stem1_tg = new TransformGroup ();
      _stem1_tg -> setName ("stem1TG");
      _stem2_tg = new TransformGroup ();
      _stem2_tg -> setName ("stem2TG");
      _scroll_tg = new TransformGroup ();
      _scroll_tg -> setName ("scrollTG");

      /*
      _ground_tg = new TransformGroup ();
      _ground_tg -> setName ("groundTG");
      _ground = new Shape3D (SHAPE_CUBE);
      _ground -> setName ("ground");
      */


      // Set up hierarchy

      //_world_tg -> addChild (_ground_tg);
      _world_tg -> addChild (_tablegrp_tg);
      _world_tg -> addChild (_vase_tg);
      _world_tg -> addChild (_scroll_tg);

      //_ground_tg -> addChild (_ground);

      _tablegrp_tg -> addChild (_table_tg);
      //_tablegrp_tg -> addChild (_vase_tg);  // if want to put vase on table
      _tablegrp_tg -> addChild (_bowl_tg);
      _tablegrp_tg -> addChild (_flowervase_tg);
      _flowervase_tg -> addChild (_rose_tg);
      _vase_tg -> addChild (_branch_tg);
      _vase_tg -> addChild (_stem1_tg);
      _vase_tg -> addChild (_stem2_tg);

      // Add shapes
      _table_tg -> addChild (&_shape [2]);
      _vase_tg -> addChild (&_shape [0]);
      _bowl_tg -> addChild (&_shape [1]);
      _flowervase_tg -> addChild (&_shape [3]);
      _rose_tg -> addChild (&_shape [4]);
      _branch_tg -> addChild (&_shape [5]);
      _stem1_tg -> addChild (&_shape [6]);
      _stem2_tg -> addChild (&_shape [7]);
      _scroll_tg -> addChild (&_shape [8]);


      // Transform objs

      // To store temp transforms
      Matrix4 transf = Matrix4 ();
      // To store current target mat
      Matrix4 * curr_mat;


      // ground
      /*
      curr_mat = _ground_tg -> getMat ();
      transf.translate (0, 45, 0);
      transf.mul (*curr_mat, *curr_mat);
      transf.scale (3,0.02,3);
      transf.mul (*curr_mat, *curr_mat);
      transf.rotate (1.0,0.0,0.0,90);
      transf.mul (*curr_mat, *curr_mat);
      */

      // translate so can rotate easily to walk in circle
      curr_mat = _tablegrp_tg -> getMat ();
      transf.translate (-200.0/_OBJS_SCALE, 10.0/_OBJS_SCALE, 0.0);
      transf.mul (*curr_mat, *curr_mat);

      curr_mat = _vase_tg -> getMat ();
      //transf.translate (0, 300.0/512.0, 0.0);  // this puts on top of stool
      transf.translate (200.0/_OBJS_SCALE, -50.0/_OBJS_SCALE, 0.0);
      transf.mul (*curr_mat, *curr_mat);

      curr_mat = _bowl_tg -> getMat ();
      transf.translate (-80.0/_OBJS_SCALE, 400.0/_OBJS_SCALE, 0.0);
      transf.mul (*curr_mat, *curr_mat);

      curr_mat = _flowervase_tg -> getMat ();
      transf.translate (150.0/_OBJS_SCALE, 450.0/_OBJS_SCALE, 0.0);
      transf.mul (*curr_mat, *curr_mat);

      curr_mat = _rose_tg -> getMat ();
      transf.scale (0.5,0.5,0.5);
      transf.mul (*curr_mat, *curr_mat);
      transf.translate (80.0/_OBJS_SCALE, -100/_OBJS_SCALE, -20.0/_OBJS_SCALE);
      transf.mul (*curr_mat, *curr_mat);
      transf.rotate (0.0,1.0,1.0,-23.0);
      transf.mul (*curr_mat, *curr_mat);
      
      curr_mat = _branch_tg -> getMat ();
      transf.scale (0.3,0.3,0.3);
      transf.mul (*curr_mat, *curr_mat);
      transf.rotate (0.0,1.0,1.0,23.0);
      transf.mul (*curr_mat, *curr_mat);
      transf.translate (-60.0/_OBJS_SCALE, -30.0/_OBJS_SCALE, 40.0/_OBJS_SCALE);
      transf.mul (*curr_mat, *curr_mat);

      // If put in flower vase as 2nd flower
      //curr_mat = _branch_tg -> getMat ();
      //transf.scale (0.1,0.1,0.1);
      //transf.mul (*curr_mat, *curr_mat);
      //transf.translate (80.0/_OBJS_SCALE, -100/_OBJS_SCALE, -20.0/_OBJS_SCALE);
      //transf.mul (*curr_mat, *curr_mat);
      //transf.rotate (0.0,1.0,1.0,23.0);
      //transf.mul (*curr_mat, *curr_mat);

      curr_mat = _stem1_tg -> getMat ();
      transf.rotate (0.0, 1.0, 1.0, -35.0);
      transf.mul (*curr_mat, *curr_mat);
      transf.translate (150.0/_OBJS_SCALE, 100.0/_OBJS_SCALE, 0.0/_OBJS_SCALE);
      transf.mul (*curr_mat, *curr_mat);

      curr_mat = _stem2_tg -> getMat ();
      transf.rotate (-0.4, 1.0, 1.0, 40.0);
      transf.mul (*curr_mat, *curr_mat);
      transf.translate (-200.0/_OBJS_SCALE, 140.0/_OBJS_SCALE,
        -70.0/_OBJS_SCALE);
      transf.mul (*curr_mat, *curr_mat);

      curr_mat = _scroll_tg -> getMat ();
      transf.rotate (0.0, 1.0, 0.0, 180+45.0);
      transf.mul (*curr_mat, *curr_mat);
      transf.rotate (0.0, 0.0, 1.0, 90.0);
      transf.mul (*curr_mat, *curr_mat);
      transf.translate (-256.0/_OBJS_SCALE, 0.0, 7.0);
      transf.mul (*curr_mat, *curr_mat);
      transf.scale (5.0, 5.0, 0.1);
      transf.mul (*curr_mat, *curr_mat);

    }


  }


  // Patch flag
  else if (_part == PART_PATCH)
  {
    int NUM_PAT_CTRLPTS = 16;

    // MUST be 16 elements
    Vector3 * _flag_ctrlpts = new Vector3 [NUM_PAT_CTRLPTS];
/*
    // width 256 * height 196
    _flag_ctrlpts [0].setAll (0, 0, 0);
    _flag_ctrlpts [1].setAll (64, 0, 0);
    _flag_ctrlpts [2].setAll (128, 0, 0);
    _flag_ctrlpts [3].setAll (192, 0, 0);
    _flag_ctrlpts [4].setAll (0, 49, 0);
    _flag_ctrlpts [5].setAll (64, 49, 0);
    _flag_ctrlpts [6].setAll (128, 49, 0);
    _flag_ctrlpts [7].setAll (192, 49, 0);
    _flag_ctrlpts [8].setAll (0, 0, 0);
    _flag_ctrlpts [9].setAll (64, 0, 0);
    _flag_ctrlpts [10].setAll (128, 0, 0);
    _flag_ctrlpts [11].setAll (192, 0, 0);
    _flag_ctrlpts [12].setAll (0, 49, 0);
    _flag_ctrlpts [13].setAll (64, 49, 0);
    _flag_ctrlpts [14].setAll (128, 49, 0);
    _flag_ctrlpts [15].setAll (192, 49, 0);
*/
    _flag_ctrlpts [0].setAll (0, 0, 0);
    _flag_ctrlpts [1].setAll (64, 0, 64);
    _flag_ctrlpts [2].setAll (128, 0, 32);
    _flag_ctrlpts [3].setAll (192, 0, 128);
    _flag_ctrlpts [4].setAll (0, 49, 0);
    _flag_ctrlpts [5].setAll (64, 49, 64);
    _flag_ctrlpts [6].setAll (128, 49, 32);
    _flag_ctrlpts [7].setAll (192, 49, 128);
    _flag_ctrlpts [8].setAll (0, 98, 0);
    _flag_ctrlpts [9].setAll (64, 98, 64);
    _flag_ctrlpts [10].setAll (128, 98, 32);
    _flag_ctrlpts [11].setAll (192, 98, 128);
    _flag_ctrlpts [12].setAll (0, 147, 0);
    _flag_ctrlpts [13].setAll (64, 147, 64);
    _flag_ctrlpts [14].setAll (128, 147, 32);
    _flag_ctrlpts [15].setAll (192, 147, 128);


    // Divide by 512 to fit to 1x1x1 frustum
    for (int i = 0; i < NUM_PAT_CTRLPTS; i ++)
      _flag_ctrlpts [i].mul (1.0/_OBJS_SCALE*2, _flag_ctrlpts [i]);

    _flag.generateSurface (_flag_ctrlpts, NUM_PAT_CTRLPTS);

    int flag_num_samplepts = 16;
    _flag.buildSurface (flag_num_samplepts);

    _flag_verts = _flag.getVerts ();
    _flag_triIndices = _flag.getTriIndices ();

    // Move from vector to array
    _flag_verts_size = _flag_verts -> size ();
    _flag_verts_arr = new float [_flag_verts_size * 3];
    for (int i = 0; i < _flag_verts_size; i++)
    {
      _flag_verts_arr [3*i] = (*(_flag_verts -> at(i))) [0];
      _flag_verts_arr [3*i+1] = (*(_flag_verts -> at(i))) [1];
      _flag_verts_arr [3*i+2] = (*(_flag_verts -> at(i))) [2];
    }
    _flag_verts -> clear ();

    // Indices to vertices making triangles
    _flag_triIndices_size = _flag_triIndices -> size ();
    _flag_triIndices_arr = new int [_flag_triIndices_size];
    for (int i = 0; i < _flag_triIndices_size; i++)
    { 
      _flag_triIndices_arr [i] = _flag_triIndices -> at (i);
    }
    _flag_triIndices -> clear ();




    // Texture
    _flag_img_w = 0;
    _flag_img_h = 0;
    _flag_texImg = _flag_ppmFile.loadPPM ("in/flag.ppm", _flag_img_w,
      _flag_img_h);
    loadTex (true, _flag_img_w, _flag_img_h, _flag_texName, _flag_texImg);

    _flag_shape = Shape ();
    _flag_material = Material ();


  }


  // hw 7. Museum
  else if (_part == PART_MUSEUM)
  {
    // OBJ - room

    //_room = new Shape3D (SHAPE_OBJ, "in/ArmilareSphere_1500century.obj");
    //_room = new Shape3D (SHAPE_OBJ, "in/teapot.obj");
    //_room = new Shape3D (SHAPE_OBJ, "in/AmerFishingBoatKetch.obj");
    _room = new Shape3D (SHAPE_OBJ, "in/room.obj");

    // material
    _room_matr = new Material ();
    _room_matr -> addChild (_room);
    //_room_matr -> setAmbient (0.9, 0.0, 0.7, 1.0);  // mysterious purple
    _room_matr -> setAmbient (0.9, 0.7, 0.0, 1.0);
    _room_matr -> setDiffuse (0.9, 0.9, 0.7, 1.0);
    _room_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _room_matr -> setShine (0);

    // texture
    
    char room_ppmFilename [PATH_MAX];
    *(room_ppmFilename) = 0;
    strcat (room_ppmFilename, "in/wall2.ppm");

    _room_tex_imgW = 0;
    _room_tex_imgH = 0;
    _room_texImg = _room_ppmFile.loadPPM (room_ppmFilename,
      _room_tex_imgW, _room_tex_imgH);
    loadTex (true, _room_tex_imgW, _room_tex_imgH, _room_texName,
      _room_texImg);

    _room -> set_sg_textureOn (true);
    _room -> set_sg_texName (_room_texName);
    _room -> setTexDim (_room_tex_imgW, _room_tex_imgH);
    _room -> set_sg_nVerts (_room_tex_verts_size);
    _room -> set_sg_verts (_room_tex_verts_arr);
    _room -> set_sg_nIndices (_room_tex_triIndices_size);
    _room -> set_sg_indices (_room_tex_triIndices_arr);
    _room -> set_sg_colors (NULL);
    _room -> set_sg_solidColor (_room_tex_solidColor);
    _room -> set_sg_normals (_room_tex_norms_arr);
    _room -> set_sg_texCoords (_room_texCoords_arr);

    _room_tg = new TransformGroup ();
    _room_tg -> setName ("roomTG");

    _room_tg -> addChild (_room_matr);
    _world_tg -> addChild (_room_tg);



    // map1
    _map1 = new Shape3D (SHAPE_QUAD);
    
    // map1 material
    _map1_matr = new Material ();
    _map1_matr -> addChild (_map1);
    _map1_matr -> setAmbient (1, 1, 1, 1.0);
    _map1_matr -> setDiffuse (1, 1, 1, 1.0);
    _map1_matr -> setSpec (1.0, 1.0, 1.0, 1.0);
    _map1_matr -> setShine (30);
    
    // map1 textures
    _map1_tex_imgH = 0;
    _map1_tex_imgW = 0;
    _map1_texImg = _map1_ppmFile.loadPPM ("in/America.ppm", _map1_tex_imgW, _map1_tex_imgH);
    loadTex (true, _map1_tex_imgW, _map1_tex_imgH, _map1_texName, _map1_texImg);


    _map1 -> set_sg_textureOn (true);
    _map1 -> set_sg_texName (_map1_texName);
    _map1 -> setTexDim (50,30);    
    _map1_tg = new TransformGroup();
    _map1_tg-> setName("map1");
    _map1_tg-> addChild(_map1_matr);
    _world_tg-> addChild(_map1_tg);

     // map2
    _map2 = new Shape3D (SHAPE_QUAD);
    
    // map2 material
    _map2_matr = new Material ();
    _map2_matr -> addChild (_map2);
    _map2_matr -> setAmbient (1, 1, 1.0, 1.0);
    _map2_matr -> setDiffuse (1, 1, 1, 1.0);
    _map2_matr -> setSpec (1.0, 1.0, 1.0, 1.0);
    _map2_matr -> setShine (0);
    
    // map2 textures
    _map2_tex_imgH = 0;
    _map2_tex_imgW = 0;
    _map2_texImg = _map2_ppmFile.loadPPM ("in/ageofexplorationmap1.ppm", _map2_tex_imgW, _map2_tex_imgH);
    loadTex (true, _map2_tex_imgW, _map2_tex_imgH, _map2_texName, _map2_texImg);


    _map2 -> set_sg_textureOn (true);
    _map2 -> set_sg_texName (_map2_texName);
    _map2 -> setTexDim (50,30);    
    _map2_tg = new TransformGroup();
    _map2_tg-> setName("map2");
    _map2_tg-> addChild(_map2_matr);
    _world_tg-> addChild(_map2_tg);

     // map3
    _map3 = new Shape3D (SHAPE_QUAD);
    
    // map3 material
    _map3_matr = new Material ();
    _map3_matr -> addChild (_map3);
    _map3_matr -> setAmbient (1, 1, 1, 1.0);
    _map3_matr -> setDiffuse (1, 1, 1, 1.0);
    _map3_matr -> setSpec (1.0, 1.0, 1.0, 1.0);
    _map3_matr -> setShine (0);
    
    // map3 textures
    _map3_tex_imgH = 0;
    _map3_tex_imgW = 0;
    _map3_texImg = _map3_ppmFile.loadPPM ("in/wall_texture01.ppm", _map3_tex_imgW, _map3_tex_imgH);
    loadTex (true, _map3_tex_imgW, _map3_tex_imgH, _map3_texName, _map3_texImg);


    _map3 -> set_sg_textureOn (true);
    _map3 -> set_sg_texName (_map3_texName);
    _map3 -> setTexDim (100,30);    
    _map3_tg = new TransformGroup();
    _map3_tg-> setName("map3");
    _map3_tg-> addChild(_map3_matr);
    _world_tg-> addChild(_map3_tg);

    // map4
    _map4 = new Shape3D (SHAPE_QUAD);
    
    // map4 material
    _map4_matr = new Material ();
    _map4_matr -> addChild (_map4);
    _map4_matr -> setAmbient (1, 1, 1.0, 1.0);
    _map4_matr -> setDiffuse (1, 1, 1, 1.0);
    _map4_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _map4_matr -> setShine (0);
    
    // map4 textures
    _map4_tex_imgH = 0;
    _map4_tex_imgW = 0;
    _map4_texImg = _map4_ppmFile.loadPPM ("in/Artic.ppm", _map4_tex_imgW, _map4_tex_imgH);
    loadTex (true, _map4_tex_imgW, _map4_tex_imgH, _map4_texName, _map4_texImg);


    _map4 -> set_sg_textureOn (true);
    _map4 -> set_sg_texName (_map4_texName);
    _map4 -> setTexDim (100,30);    
    _map4_tg = new TransformGroup();
    _map4_tg-> setName("map4");
    _map4_tg-> addChild(_map4_matr);
    _world_tg-> addChild(_map4_tg);

    // cieling
    _cieling = new Shape3D (SHAPE_QUAD);
    
    // cieling material
    _cieling_matr = new Material ();
    _cieling_matr -> addChild (_cieling);
    _cieling_matr -> setAmbient (1,1 ,1, 1.0);
    _cieling_matr -> setDiffuse (.6235, .6235, .3725, 1.0);
    _cieling_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _cieling_matr -> setShine (0);
    
    // cieling textures
    _cieling_tex_imgH = 0;
    _cieling_tex_imgW = 0;
    _cieling_texImg = _cieling_ppmFile.loadPPM ("in/cieling.ppm", _cieling_tex_imgW, _cieling_tex_imgH);
    loadTex (true, _cieling_tex_imgW, _cieling_tex_imgH, _cieling_texName, _cieling_texImg);


    _cieling -> set_sg_textureOn (true);
    _cieling -> set_sg_texName (_cieling_texName);
    _cieling -> setTexDim (2500,2500);    
    _cieling_tg = new TransformGroup();
    _cieling_tg-> setName("cieling");
    _cieling_tg-> addChild(_cieling_matr);
    _world_tg-> addChild(_cieling_tg);

    // floor
    _floor = new Shape3D (SHAPE_QUAD);
    
    // floor material
    _floor_matr = new Material ();
    _floor_matr -> addChild (_floor);
    _floor_matr -> setAmbient (1, 1, 1.0, 1.0);
    _floor_matr -> setDiffuse (.52, .37, .26, 1.0);
    _floor_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _floor_matr -> setShine (0);
    
    // floor textures
    _floor_tex_imgH = 0;
    _floor_tex_imgW = 0;
    _floor_texImg = _floor_ppmFile.loadPPM ("in/floor.ppm", _floor_tex_imgW, _floor_tex_imgH);
    loadTex (true, _floor_tex_imgW, _floor_tex_imgH, _floor_texName, _floor_texImg);


    _floor -> set_sg_textureOn (true);
    _floor -> set_sg_texName (_floor_texName);
    _floor -> setTexDim (2500,2500);    
    _floor_tg = new TransformGroup();
    _floor_tg-> setName("floor");
    _floor_tg-> addChild(_floor_matr);
    _world_tg-> addChild(_floor_tg);

      // fract_tree1
    _fract_tree1 = new Shape3D (SHAPE_TREE);
    
    // fract_tree1
    _fract_tree1_matr = new Material ();
    _fract_tree1_matr -> addChild (_fract_tree1);
    _fract_tree1_matr -> setAmbient (.8,.196078 , .6, 1.0);
    _fract_tree1_matr -> setDiffuse (.137255, .556863, .137255, 1.0);
    _fract_tree1_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _fract_tree1_matr -> setShine (0);
    
    _fract_tree1 -> set_sg_textureOn (false); 
    _fract_tree1_tg = new TransformGroup();
    _fract_tree1_tg-> setName("fract tree1");
    _fract_tree1_tg-> addChild(_fract_tree1_matr);
    _world_tg-> addChild(_fract_tree1_tg);

    
    // fract_tree2
    _fract_tree2_matr = new Material ();
    _fract_tree2_matr -> addChild (_fract_tree1);
    _fract_tree2_matr -> setAmbient (.89,.47 ,.20, 1.0);
    _fract_tree2_matr -> setDiffuse (.137255, .419608, .556863, 1.0);
    _fract_tree2_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _fract_tree2_matr -> setShine (0);
        
    _fract_tree2_tg = new TransformGroup();
    _fract_tree2_tg-> setName("fract tree2");
    _fract_tree2_tg-> addChild(_fract_tree2_matr);
    _world_tg-> addChild(_fract_tree2_tg);
      
    // fract_tree3
    _fract_tree3_matr = new Material ();
    _fract_tree3_matr -> addChild (_fract_tree1);
    _fract_tree3_matr -> setAmbient (.6,.8 , .6, .196078);
    _fract_tree3_matr -> setDiffuse (.55,.09,.09, 1.0);
    _fract_tree3_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _fract_tree3_matr -> setShine (0);
        
    _fract_tree3_tg = new TransformGroup();
    _fract_tree3_tg-> setName("fract tree3");
    _fract_tree3_tg-> addChild(_fract_tree3_matr);
    _world_tg-> addChild(_fract_tree3_tg);


    // OBJ - Globe stand 1500 century Armilare sphere

    *(objFilename) = 0;
    strcat (objFilename, "in/ArmilareSphere_1500century2.obj");
    _globe = new Shape3D (SHAPE_OBJ, objFilename);

    // material
    _globe_matr = new Material ();
    _globe_matr -> addChild (_globe);
    _globe_matr -> setAmbient (0.9, 0.5, 0.0, 1.0);
    _globe_matr -> setDiffuse (0.9, 0.5, 0.4, 1.0);
    _globe_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _globe_matr -> setShine (0);

    _globe_tg = new TransformGroup ();
    _globe_tg -> setName ("globeTG");

    _globe_tg -> addChild (_globe_matr);
    _room_tg -> addChild (_globe_tg);
    
    //env mapping on
    _globe -> set_sg_envMapOn(true);
    _globe -> set_face_files(faceFile1);


    /*
    // OBJ - Balance

    *(objFilename) = 0;
    strcat (objFilename, "in/balance.obj");
    _balance = new Shape3D (SHAPE_OBJ, objFilename);

    // material
    _balance_matr = new Material ();
    _balance_matr -> addChild (_balance);
    _balance_matr -> setAmbient (0.9, 0.0, 0.0, 1.0);
    _balance_matr -> setDiffuse (0.9, 0.9, 0.4, 1.0);
    _balance_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _balance_matr -> setShine (0);

    _balance_tg = new TransformGroup ();
    _balance_tg -> setName ("balanceTG");

    _balance_tg -> addChild (_balance_matr);
    _room_tg -> addChild (_balance_tg);
    */


    // OBJ - Greek ship

    *(objFilename) = 0;
    strcat (objFilename, "in/greekAncient.obj");
    _ship_greek = new Shape3D (SHAPE_OBJ, objFilename);

    // material
    _ship_greek_matr = new Material ();
    _ship_greek_matr -> addChild (_ship_greek);
    _ship_greek_matr -> setAmbient (0.9, 0.0, 0.0, 1.0);
    _ship_greek_matr -> setDiffuse (0.9, 0.9, 0.4, 1.0);
    _ship_greek_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_greek_matr -> setShine (0);

    _ship_greek_tg = new TransformGroup ();
    _ship_greek_tg -> setName ("ship_greekTG");

    _ship_greek_tg -> addChild (_ship_greek_matr);
    _room_tg -> addChild (_ship_greek_tg);


    // OBJ - Greek ship SAILS

    *(objFilename) = 0;
    strcat (objFilename, "in/greekAncient_sails.obj");
    _ship_greekSail = new Shape3D (SHAPE_OBJ, objFilename);

    // material
    _ship_greekSail_matr = new Material ();
    _ship_greekSail_matr -> addChild (_ship_greekSail);
    _ship_greekSail_matr -> setAmbient (0.9, 0.0, 0.4, 1.0);
    _ship_greekSail_matr -> setDiffuse (0.9, 0.9, 0.4, 1.0);
    _ship_greekSail_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_greekSail_matr -> setShine (0);

    _ship_greekSail_tg = new TransformGroup ();
    _ship_greekSail_tg -> setName ("ship_greekSailTG");

    _ship_greekSail_tg -> addChild (_ship_greekSail_matr);
    _room_tg -> addChild (_ship_greekSail_tg);


    // OBJ - Galeon ship
    *(objFilename) = 0;
    //strcat (objFilename, "in/oldGaleonShip.obj");
    strcat (objFilename, "in/galeon.obj");
    _ship_galeon = new Shape3D (SHAPE_OBJ, objFilename);

    // load ship texture
    _ship_galeon_tex_imgH = 0;
    _ship_galeon_tex_imgW = 0;
    _ship_galeon_texImg = _ship_galeon_ppmFile.loadPPM ("in/silver.ppm", _ship_galeon_tex_imgW, _ship_galeon_tex_imgH);
    loadTex (true, _ship_galeon_tex_imgW, _ship_galeon_tex_imgH, _ship_galeon_texName, _ship_galeon_texImg);

    // material
    _ship_galeon_matr = new Material ();
    _ship_galeon_matr -> addChild (_ship_galeon);
    _ship_galeon_matr -> setAmbient (0.5, 0.5, 0.0, 1.0);
    _ship_galeon_matr -> setDiffuse (0.5, 0.5, 0.4, 1.0);
    _ship_galeon_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_galeon_matr -> setShine (0);
   
    _ship_galeon -> set_sg_textureOn (true);
    _ship_galeon -> set_sg_texName (_ship_galeon_texName);
    _ship_galeon -> setTexDim (_ship_galeon_tex_imgW, _ship_galeon_tex_imgH);
    _ship_galeon -> set_sg_nVerts (_ship_galeon_tex_verts_size);
    _ship_galeon -> set_sg_verts (_ship_galeon_tex_verts_arr);
    _ship_galeon -> set_sg_nIndices (_ship_galeon_tex_triIndices_size);
    _ship_galeon -> set_sg_indices (_ship_galeon_tex_triIndices_arr);
    _ship_galeon -> set_sg_colors (NULL);
    _ship_galeon -> set_sg_solidColor (_ship_galeon_tex_solidColor);
    _ship_galeon -> set_sg_normals (_ship_galeon_tex_norms_arr);
    _ship_galeon -> set_sg_texCoords (_ship_galeon_texCoords_arr);
    
    _ship_galeon_tg = new TransformGroup ();
    _ship_galeon_tg -> setName ("ship_galeonTG");

    _ship_galeon_tg -> addChild (_ship_galeon_matr);
    _room_tg -> addChild (_ship_galeon_tg);


    // OBJ - Glorieux ship

    *(objFilename) = 0;
    strcat (objFilename, "in/1782LeGlorieuxCapturedByBritish_3861.obj");
    _ship_glorieux = new Shape3D (SHAPE_OBJ, objFilename);

    _ship_glorieux_matr = new Material();
    _ship_glorieux_matr -> addChild (_ship_glorieux);
    _ship_glorieux_matr -> setAmbient (0.8, 0.6, 0.0, 1.0);
    _ship_glorieux_matr -> setDiffuse (0.8, 0.6, 0.0, 1.0);
    _ship_glorieux_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_glorieux_matr -> setShine (0);

    _ship_glorieux_tg = new TransformGroup();
    _ship_glorieux_tg -> setName ("ship_glorieuxTG");
    _ship_glorieux_tg -> addChild (_ship_glorieux_matr);
    _room_tg -> addChild (_ship_glorieux_tg);


    // OBJ - Reale de France

    *(objFilename) = 0;
    strcat (objFilename, "in/17centuryKingsPersonalShip_RealeDeFrance_3673.obj");
    _ship_realedefr = new Shape3D (SHAPE_OBJ, objFilename);

    _ship_realedefr_matr = new Material();
    _ship_realedefr_matr -> addChild (_ship_realedefr);
    _ship_realedefr_matr -> setAmbient (0.5, 0.5, 0.0, 1.0);
    _ship_realedefr_matr -> setDiffuse (0, .25, .60, 1.0);
    _ship_realedefr_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_realedefr_matr -> setShine (0);

    _ship_realedefr_tg = new TransformGroup();
    _ship_realedefr_tg -> setName ("ship_realedefrTG");
    _ship_realedefr_tg -> addChild (_ship_realedefr_matr);
    _room_tg -> addChild (_ship_realedefr_tg);


    // OBJ - Reale de France FLAGS

    *(objFilename) = 0;
    strcat (objFilename, "in/17centuryKingsPersonalShip_RealeDeFrance_flags.obj");
    _ship_realedefrSail = new Shape3D (SHAPE_OBJ, objFilename);

    _ship_realedefrSail_matr = new Material();
    _ship_realedefrSail_matr -> addChild (_ship_realedefrSail);
    _ship_realedefrSail_matr -> setAmbient (0.9, 0.3, 0.2, 1.0);
    _ship_realedefrSail_matr -> setDiffuse (0.9, 0.3, 0.2, 1.0);
    _ship_realedefrSail_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_realedefrSail_matr -> setShine (0);

    _ship_realedefrSail_tg = new TransformGroup();
    _ship_realedefrSail_tg -> setName ("ship_realedefrSailTG");
    _ship_realedefrSail_tg -> addChild (_ship_realedefrSail_matr);
    _room_tg -> addChild (_ship_realedefrSail_tg);




/*
    // OBJ - Chess ship

    *(objFilename) = 0;
    strcat (objFilename, "in/chessShip.obj");
    _ship_chess = new Shape3D (SHAPE_OBJ, objFilename);

    _ship_chess_matr = new Material();
    _ship_chess_matr -> addChild (_ship_chess);
    _ship_chess_matr -> setAmbient (0.5, 0.5, 0.0, 1.0);
    _ship_chess_matr -> setDiffuse (0, .25, .60, 1.0);
    _ship_chess_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_chess_matr -> setShine (0);

    _ship_chess_tg = new TransformGroup();
    _ship_chess_tg -> setName ("ship_chessTG");
    _ship_chess_tg -> addChild (_ship_chess_matr);
    _room_tg -> addChild (_ship_chess_tg);
*/

    /*
    // OBJ - LowPoly Galleon

    *(objFilename) = 0;
    strcat (objFilename, "in/lowPolyGalleon_9515.obj");
    _ship_lowpolyGalleon = new Shape3D (SHAPE_OBJ, objFilename);

    _ship_lowpolyGalleon_matr = new Material();
    _ship_lowpolyGalleon_matr -> addChild (_ship_lowpolyGalleon);
    _ship_lowpolyGalleon_matr -> setAmbient (0.5, 0.5, 0.0, 1.0);
    _ship_lowpolyGalleon_matr -> setDiffuse (0, .25, .60, 1.0);
    _ship_lowpolyGalleon_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_lowpolyGalleon_matr -> setShine (0);

    _ship_lowpolyGalleon_tg = new TransformGroup();
    _ship_lowpolyGalleon_tg -> setName ("ship_lowpolyGalleonTG");
    _ship_lowpolyGalleon_tg -> addChild (_ship_lowpolyGalleon_matr);
    _room_tg -> addChild (_ship_lowpolyGalleon_tg);
    */


    // OBJ - ship roman

    *(objFilename) = 0;
    strcat (objFilename, "in/roman.obj");
    _ship_roman = new Shape3D (SHAPE_OBJ, objFilename);

    _ship_roman_matr = new Material();
    _ship_roman_matr -> addChild (_ship_roman);
    _ship_roman_matr -> setAmbient (0.5, 0.5, 0.0, 1.0);
    _ship_roman_matr -> setDiffuse (0, .25, .60, 1.0);
    _ship_roman_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_roman_matr -> setShine (0);

    _ship_roman_tg = new TransformGroup();
    _ship_roman_tg -> setName ("ship_romanTG");
    _ship_roman_tg -> addChild (_ship_roman_matr);
    _room_tg -> addChild (_ship_roman_tg);


    // OBJ - ship tallClipper
    *(objFilename) = 0;
    strcat (objFilename, "in/tallClipperSailboat_beautiful_part_3913.obj");
    _ship_tallClipper = new Shape3D (SHAPE_OBJ, objFilename);

    _ship_tallClipper_matr = new Material();
    _ship_tallClipper_matr -> addChild (_ship_tallClipper);
    _ship_tallClipper_matr -> setAmbient (0.5, 0.5, 0.0, 1.0);
    _ship_tallClipper_matr -> setDiffuse (0.8, 0.3, 0.0, 1.0);
    _ship_tallClipper_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_tallClipper_matr -> setShine (0);

    _ship_tallClipper_tg = new TransformGroup();
    _ship_tallClipper_tg -> setName ("ship_tallClipper_TG");
    _ship_tallClipper_tg -> addChild (_ship_tallClipper_matr);
    _room_tg -> addChild (_ship_tallClipper_tg);


    // OBJ - ship tallClipper SAILS
    *(objFilename) = 0;
    strcat (objFilename, "in/tallClipperSailboat_beautiful_part_sails.obj");
    _ship_tallClipperSail = new Shape3D (SHAPE_OBJ, objFilename);

    _ship_tallClipperSail_matr = new Material();
    _ship_tallClipperSail_matr -> addChild (_ship_tallClipperSail);
    _ship_tallClipperSail_matr -> setAmbient (1.0, 1.0, 0.8, 1.0);
    _ship_tallClipperSail_matr -> setDiffuse (1.0, 1.0, 0.8, 1.0);
    _ship_tallClipperSail_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_tallClipperSail_matr -> setShine (0);

    _ship_tallClipperSail_tg = new TransformGroup();
    _ship_tallClipperSail_tg -> setName ("ship_tallClipperSail_TG");
    _ship_tallClipperSail_tg -> addChild (_ship_tallClipperSail_matr);
    _room_tg -> addChild (_ship_tallClipperSail_tg);
  

    // Barrels file has problems. Do NOT use it

/*

    // OBJ - table1

    *(objFilename) = 0;
    strcat (objFilename, "in/table.obj");
    _table1 = new Shape3D (SHAPE_OBJ, objFilename);

    _table1_matr = new Material();
    _table1_matr -> addChild (_table1);
    _table1_matr -> setAmbient (0.5, 0.5, 0.0, 1.0);
    _table1_matr -> setDiffuse (0, .25, .60, 1.0);
    _table1_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _table1_matr -> setShine (0);

    _table1_tg = new TransformGroup();
    _table1_tg -> setName ("table1_TG");
    _table1_tg -> addChild (_table1_matr);
    _table1_tg -> addChild (_table1_tg);
    _room_tg -> addChild (_table1_tg);

*/    

    // OBJ - San Juan battleship

    *objFilename = 0;
    strcat (objFilename, "in/SunJuan50battleship_2824.obj");
    _ship_sanjuan = new Shape3D (SHAPE_OBJ, objFilename);

    // material
    _ship_sanjuan_matr = new Material ();
    _ship_sanjuan_matr -> addChild (_ship_sanjuan);
    _ship_sanjuan_matr -> setAmbient (0.9, 0.9, 0.0, 1.0);
    _ship_sanjuan_matr -> setDiffuse (0.9, 0.9, 0.0, 1.0);
    _ship_sanjuan_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_sanjuan_matr -> setShine (0);

    _ship_sanjuan_tg = new TransformGroup ();
    _ship_sanjuan_tg -> setName ("ship_sanjuanTG");

    _ship_sanjuan_tg -> addChild (_ship_sanjuan_matr);
    _room_tg -> addChild (_ship_sanjuan_tg);


    // OBJ - San Juan battleship SAILS

    *objFilename = 0;
    strcat (objFilename, "in/SunJuan50battleship_sails.obj");
    _ship_sanjuanSail = new Shape3D (SHAPE_OBJ, objFilename);

    // material
    _ship_sanjuanSail_matr = new Material ();
    _ship_sanjuanSail_matr -> addChild (_ship_sanjuanSail);
    _ship_sanjuanSail_matr -> setAmbient (1.0, 1.0, 0.7, 1.0);
    _ship_sanjuanSail_matr -> setDiffuse (1.0, 1.0, 0.7, 1.0);
    _ship_sanjuanSail_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _ship_sanjuanSail_matr -> setShine (0);

    _ship_sanjuanSail_tg = new TransformGroup ();
    _ship_sanjuanSail_tg -> setName ("ship_sanjuanSailTG");

    _ship_sanjuanSail_tg -> addChild (_ship_sanjuanSail_matr);
    _room_tg -> addChild (_ship_sanjuanSail_tg);
  

    // OBJ - Dividing chains

    *(objFilename) = 0;
    strcat (objFilename, "in/chains.obj");
    _chain1 = new Shape3D (SHAPE_OBJ, objFilename);

    // material
    _chain1_matr = new Material ();
    _chain1_matr -> addChild (_chain1);
    _chain1_matr -> setAmbient (0.9, 0.9, 0.0, 1.0);
    _chain1_matr -> setDiffuse (0.9, 0.9, 0.0, 1.0);
    _chain1_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _chain1_matr -> setShine (0);

    _chain1_tg = new TransformGroup ();
    _chain1_tg -> setName ("chain1TG");

    _chain1_tg -> addChild (_chain1_matr);
    _room_tg -> addChild (_chain1_tg);

    //env mapping on
    _chain1 -> set_sg_envMapOn(true);
    _chain1 -> set_face_files(faceFile1);



    // backdrop
    _bg = new Shape3D (SHAPE_QUAD);

    // backdrop material
    _bg_matr = new Material ();
    _bg_matr -> addChild (_bg);
    _bg_matr -> setAmbient (0.9, 0.7, 0.0, 1.0);
    _bg_matr -> setDiffuse (0.9, 0.9, 0.4, 1.0);
    _bg_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _bg_matr -> setShine (0);
  
    // backdrop textures
    _bg_tex_imgH = 0;
    _bg_tex_imgW = 0;
    _bg_texImg = _bg_ppmFile.loadPPM ("in/bg14_Dresden.ppm", _bg_tex_imgW,
      _bg_tex_imgH);
    loadTex (true, _bg_tex_imgW, _bg_tex_imgH, _bg_texName, _bg_texImg);

    _bg -> set_sg_textureOn (true);
    _bg -> set_sg_texName (_bg_texName);
    _bg -> setTexDim (50,30);    
    _bg_tg = new TransformGroup();
    _bg_tg-> setName("bg");
    _bg_tg-> addChild(_bg_matr);
    _world_tg-> addChild(_bg_tg);


    // ground
    _grd = new Shape3D (SHAPE_QUAD);

    // backdrop material
    _grd_matr = new Material ();
    _grd_matr -> addChild (_grd);
    _grd_matr -> setAmbient (0.9, 0.7, 0.0, 1.0);
    _grd_matr -> setDiffuse (0.9, 0.9, 0.4, 1.0);
    _grd_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _grd_matr -> setShine (0);
  
    // backdrop textures
    _grd_tex_imgH = 0;
    _grd_tex_imgW = 0;
    _grd_texImg = _grd_ppmFile.loadPPM ("in/grd03.ppm", _grd_tex_imgW,
      _grd_tex_imgH);
    loadTex (true, _grd_tex_imgW, _grd_tex_imgH, _grd_texName, _grd_texImg);

    _grd -> set_sg_textureOn (true);
    _grd -> set_sg_texName (_grd_texName);
    _grd -> setTexDim (50,30);    
    _grd_tg = new TransformGroup();
    _grd_tg-> setName("grd");
    _grd_tg-> addChild(_grd_matr);
    _world_tg-> addChild(_grd_tg);


    /*
    // glass
    _glass1 = new Shape3D (SHAPE_QUAD);
    // turn on blending for translucency
    _glass1 -> setBlend (true);
    _glass1 -> setStatic (false);

    // backdrop material
    _glass1_matr = new Material ();
    _glass1_matr -> addChild (_glass1);
    _glass1_matr -> setAmbient (0.0, 0.5, 0.5, 0.5);
    _glass1_matr -> setDiffuse (0.0, 0.5, 0.5, 0.5);
    _glass1_matr -> setSpec (0.0, 0.0, 0.0, 0.5);
    _glass1_matr -> setShine (0);
  
    _glass1_tg = new TransformGroup();
    _glass1_tg-> setName("glass1");
    _glass1_tg-> addChild(_glass1_matr);
    _world_tg-> addChild(_glass1_tg);
    */
    

   // OBJ - Sculpture
    *(objFilename) = 0;
    strcat (objFilename, "in/david.obj");
    _david = new Shape3D (SHAPE_OBJ, objFilename);

    // material
    _david_matr = new Material ();
    _david_matr -> addChild (_david);
    _david_matr -> setAmbient (0.9, 0.9, 0.0, 1.0);
    _david_matr -> setDiffuse (0.9, 0.9, 0.0, 1.0);
    _david_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _david_matr -> setShine (0);

    // env mapping
    _david -> set_sg_envMapOn(true);
    _david -> set_face_files(faceFile2);


    _david_tg = new TransformGroup ();
    _david_tg -> setName ("david");

    _david_tg -> addChild (_david_matr);
    _room_tg -> addChild (_david_tg);

   
    // Particle system 1

    _psys1 = new PartSys ();

    _psys1_tg = new TransformGroup ();
    _psys1_tg -> setName ("PartSys1TG");

    // material
    _psys1_matr = new Material ();
    _psys1_matr -> addChild (_psys1);
    _psys1_matr -> setAmbient (0.9, 0.0, 0.0, 0.5);
    _psys1_matr -> setDiffuse (0.9, 0.0, 0.0, 0.5);
    _psys1_matr -> setSpec (0.0, 0.0, 0.0, 0.5);
    _psys1_matr -> setShine (0);

    _psys1_tg -> addChild (_psys1_matr);
    _room_tg -> addChild (_psys1_tg);


    // Particle system 2 - uses same geometry as psys1

    _psys2_tg = new TransformGroup ();
    _psys2_tg -> setName ("PartSys2TG");

    _psys2_tg -> addChild (_psys1_matr);
    _room_tg -> addChild (_psys2_tg);


    // Particle system 3 - uses same geometry as psys1

    _psys3_tg = new TransformGroup ();
    _psys3_tg -> setName ("PartSys3TG");

    _psys3_tg -> addChild (_psys1_matr);
    _room_tg -> addChild (_psys3_tg);




    // L System 1

    _lsys1 = new LSys ();

    // material
    _lsys1_matr = new Material ();
    _lsys1_matr -> addChild (_lsys1);
    //_lsys1_matr -> setAmbient (0.9, 0.0, 0.7, 1.0);  // mysterious purple
    _lsys1_matr -> setAmbient (0.0, 0.9, 0.0, 1.0);
    _lsys1_matr -> setDiffuse (0.9, 0.9, 0.4, 1.0);
    _lsys1_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _lsys1_matr -> setShine (0);

    _lsys1_tg = new TransformGroup ();
    _lsys1_tg -> setName ("LSys1TG");

    _lsys1_tg -> addChild (_lsys1_matr);
// remove temporarilly for testing other things
    _world_tg -> addChild (_lsys1_tg);


    // L System 2 - uses same geometry as L Sys 1

    // material
    _lsys2_matr = new Material ();
    _lsys2_matr -> addChild (_lsys1);  // use same geometry lsys1
    _lsys2_matr -> setAmbient (0.9, 0.0, 0.7, 1.0);
    _lsys2_matr -> setDiffuse (0.9, 0.9, 0.4, 1.0);
    _lsys2_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _lsys2_matr -> setShine (0);

    _lsys2_tg = new TransformGroup ();
    _lsys2_tg -> setName ("LSys2TG");

    _lsys2_tg -> addChild (_lsys2_matr);
// remove temporarilly for testing other things
    _world_tg -> addChild (_lsys2_tg);



    // L System grammar

    /* Grammar 1 - see lsys.cpp for specs

    // -- Grammar 1 starts --

    // Remember to change #define in lsys.h to NUM_VARS = 1, NUM_CONSTS = 5

    // assert, if not right, will print msg at run-time so we can do quick fix
    _lsys1 -> assertNumVars (1);
    _lsys1 -> assertNumConsts (5);

    // axiom
    _lsys1 -> setAxiom ("AB");

    // vars
    _lsys1 -> setVar (0, 'B', ACTION_DRAW);
    _lsys1 -> setRpl (0, "A + A [- B][+ B]");

    // consts
    _lsys1 -> setConst (0, 'A', ACTION_DRAW);
    _lsys1 -> setConst (1, '+', ACTION_TURN, 45.0f);
    _lsys1 -> setConst (2, '-', ACTION_TURN, -45.0f);
    _lsys1 -> setConst (3, '[', ACTION_PUSH);
    _lsys1 -> setConst (4, ']', ACTION_POP);

    _lsys1 -> setNumRecur (3);

    // -- Grammar 1 ends --
    */

    /*
    // -- Grammar 2 starts --

    // Remember to change #define in lsys.h to NUM_VARS = 2, NUM_CONSTS = 4

    // assert, if not right, will print msg at run-time so we can do quick fix
    _lsys1 -> assertNumVars (2);
    _lsys1 -> assertNumConsts (6);

    // axiom
    _lsys1 -> setAxiom ("X");

    // vars
    _lsys1 -> setVar (0, 'X', ACTION_NONE);
    //_lsys1 -> setRpl (0, "F-[[X]+X]+F[+FX]-X");
    _lsys1 -> setRpl (0, "F-[[X]^X]+F[+FX]vX");
    _lsys1 -> setVar (1, 'F', ACTION_DRAW);
    _lsys1 -> setRpl (1, "FF");

    // consts
    _lsys1 -> setConst (0, '+', ACTION_TURN, -25.0f);
    _lsys1 -> setConst (1, '-', ACTION_TURN, 25.0f);
    _lsys1 -> setConst (2, '[', ACTION_PUSH);
    _lsys1 -> setConst (3, ']', ACTION_POP);
    // 3d turns
    _lsys1 -> setConst (4, '^', ACTION_TURN, -25.0f, TURN_X);
    _lsys1 -> setConst (5, 'v', ACTION_TURN, 25.0f, TURN_X);
    //_lsys1 -> setConst (6, '<', ACTION_TURN, -25.0f, TURN_Y);
    //_lsys1 -> setConst (7, '<', ACTION_TURN, 25.0f, TURN_Y);

    _lsys1 -> setNumRecur (3);
   
    // -- Grammar 2 ends --
    */


    // -- Grammar 3 starts --

    // assert, if not right, will print msg at run-time so we can do quick fix
    _lsys1 -> assertNumVars (1);
    _lsys1 -> assertNumConsts (6);


    // axiom
    _lsys1 -> setAxiom ("F");

    // vars
    _lsys1 -> setVar (0, 'F', ACTION_DRAW);
    // grammar 3. ang 23. favorite bush
    //_lsys1 -> setRpl (0, "FF-[-F+F+F]+[+F-F-F]");
    // 3D from bush
    _lsys1 -> setRpl (0, "FF-[-F+F+F]+[+F-F-F]^[^FvFvF]v[vF^F^F]");
    // grammar 3. ang 23. seaweed
    //_lsys1 -> setRpl (0, "FF-F[-F+F+F]+F[+F-F-F]");
    //_lsys1 -> setRpl (0, "F[+F]F[-F]F");  // grammar 4. ang 23.5
    //_lsys1 -> setRpl (0, "F[vF+F]F[-F>F][-F>F][vF]");  // grammar 5. ang 28

    // consts
    _lsys1 -> setConst (0, '+', ACTION_TURN, 23.0f);
    _lsys1 -> setConst (1, '-', ACTION_TURN, -23.0f);
    _lsys1 -> setConst (2, '[', ACTION_PUSH);
    _lsys1 -> setConst (3, ']', ACTION_POP);
    // 3d turns
    // change indices as you need. 4 5 6 7 numbers so that they fit in array
    _lsys1 -> setConst (4, '^', ACTION_TURN, -23.0f, TURN_X);
    _lsys1 -> setConst (5, 'v', ACTION_TURN, 23.0f, TURN_X);
    //_lsys1 -> setConst (6, '<', ACTION_TURN, 28.0f, TURN_Y);
    //_lsys1 -> setConst (7, '>', ACTION_TURN, -28.0f, TURN_Y);

    //_lsys1 -> setDrawLen (2);
    _lsys1 -> setNumRecur (2);

    // -- Grammar 3 ends --
    //


    /*
    // -- Grammar 4 starts --

    // assert, if not right, will print msg at run-time so we can do quick fix
    _lsys1 -> assertNumVars (2);
    _lsys1 -> assertNumConsts (8);

    // axiom
    _lsys1 -> setAxiom ("X");

    // vars
    _lsys1 -> setVar (0, 'F', ACTION_DRAW);
    _lsys1 -> setRpl (0, "FF[^X]F[>X][vX]");
    _lsys1 -> setVar (1, 'X', ACTION_DRAW);
    _lsys1 -> setRpl (1, "F[+X]F[-X]+X[<X]");

    // consts
    _lsys1 -> setConst (0, '+', ACTION_TURN, 18.0f);
    _lsys1 -> setConst (1, '-', ACTION_TURN, -18.0f);
    _lsys1 -> setConst (2, '[', ACTION_PUSH);
    _lsys1 -> setConst (3, ']', ACTION_POP);
    // 3d turns
    // change indices as you need. 4 5 6 7 numbers so that they fit in array
    _lsys1 -> setConst (4, '^', ACTION_TURN, -18.0f, TURN_X);
    _lsys1 -> setConst (5, 'v', ACTION_TURN, 18.0f, TURN_X);
    _lsys1 -> setConst (6, '<', ACTION_TURN, 18.0f, TURN_Y);
    _lsys1 -> setConst (7, '>', ACTION_TURN, -18.0f, TURN_Y);

    //_lsys1 -> setDrawLen (2);
    _lsys1 -> setNumRecur (2);

    // -- Grammar 4 ends --
    */





    // Set up transformation of each piece

    // To store temp transforms
    Matrix4 transf = Matrix4 ();
    // To store current target mat
    Matrix4 * curr_mat;

    // room
    curr_mat = _room_tg -> getMat ();
    transf.translate (0,-100,-20);
    transf.mul (*curr_mat, *curr_mat);

    // backdrop
    curr_mat = _bg_tg -> getMat ();
    transf.scale (510.2,-120.8,1);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate(-2500,200,-3000);
    transf.mul(*curr_mat, *curr_mat);

    // ground
    curr_mat = _grd_tg -> getMat ();
    transf.scale (510.2,-120.8,1);
    transf.mul (*curr_mat, *curr_mat);
    transf.rotateX(90);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate(-1665,-180,-2000);
    transf.mul(*curr_mat, *curr_mat);


    /*
    // glass
    curr_mat = _glass1_tg -> getMat ();
    transf.scale (0.25,0.25,1);
    transf.mul (*curr_mat, *curr_mat);
    transf.rotateY(90);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate(-200,0,-1000);
    transf.mul(*curr_mat, *curr_mat);
    */

    // Transform Venus
    curr_mat = _david_tg -> getMat();
    transf.scale(4,4,4);
    transf.mul (*curr_mat, *curr_mat);
    transf.translate(-400,0,-2300);
    transf.mul (*curr_mat, *curr_mat);



    // Transform L Sys
    curr_mat = _lsys1_tg -> getMat ();
    transf.translate (-250, -100, -200);
    transf.mul (*curr_mat, *curr_mat);

    curr_mat = _lsys2_tg -> getMat ();
    transf.translate (-150, -100, -200);
    transf.mul (*curr_mat, *curr_mat);


    // particle sys
    // left aisle, 1st
    curr_mat = _psys1_tg -> getMat ();
    transf.translate (-150, 250, -350);
    transf.mul (*curr_mat, *curr_mat);

    // right aisle, 1st
    curr_mat = _psys2_tg -> getMat ();
    transf.translate (500, 250, -350);
    transf.mul (*curr_mat, *curr_mat);

    // left aisle, 2nd
    curr_mat = _psys3_tg -> getMat ();
    transf.translate (-150, 250, -1000);
    transf.mul (*curr_mat, *curr_mat);

    
	// Transform quad map1
    curr_mat = _map1_tg -> getMat ();
    
    transf.scale (10,-11,1);
    transf.mul (*curr_mat, *curr_mat);
    
    transf.rotateY(90);
    transf.mul (*curr_mat, *curr_mat);

    transf.translate(-245,100,-1300);
    transf.mul(*curr_mat, *curr_mat);

    // Transform quad map2
    curr_mat = _map2_tg -> getMat ();
    
    transf.scale (10,-11,1);
    transf.mul (*curr_mat, *curr_mat);
    
    transf.rotateY(-90);
    transf.mul (*curr_mat, *curr_mat);

    transf.translate(-1665,100,-1000);
    transf.mul(*curr_mat, *curr_mat);

    // Transform quad map3
    curr_mat = _map3_tg -> getMat ();
    
    transf.scale (10,-11,1);
    transf.mul (*curr_mat, *curr_mat);
    
    transf.rotateY(180);
    transf.mul (*curr_mat, *curr_mat);

    transf.translate(-950,100,-370);
    transf.mul(*curr_mat, *curr_mat);

     // Transform quad map4
    curr_mat = _map4_tg -> getMat ();
    
    transf.scale (10,-11,1);
    transf.mul (*curr_mat, *curr_mat);
    
    transf.rotateY(0);
    transf.mul (*curr_mat, *curr_mat);

    transf.translate(-950,100,-1620);
    transf.mul(*curr_mat, *curr_mat);
   
    // Transform ceiling
    curr_mat = _cieling_tg -> getMat ();
    
    transf.scale (1.5,1.2,1);
    transf.mul (*curr_mat, *curr_mat);
    
    transf.rotateX(90);
    transf.mul (*curr_mat, *curr_mat);

    transf.translate(0,400,-1200);
    transf.mul(*curr_mat, *curr_mat);

    // Transform floor
    curr_mat = _floor_tg -> getMat ();
    
    transf.scale (1.5,1.35,1);
    transf.mul (*curr_mat, *curr_mat);
    
    transf.rotateX(-90);
    transf.mul (*curr_mat, *curr_mat);

    transf.translate(0,-99,-1900);
    transf.mul(*curr_mat, *curr_mat);

    // Transform tree1
    curr_mat = _fract_tree1_tg -> getMat();
    transf.scale(3,3,3);
    transf.mul(*curr_mat, *curr_mat);
    transf.translate(-220,-95,-190);
    transf.mul(*curr_mat, *curr_mat);

    // Transform tree2
    curr_mat = _fract_tree2_tg -> getMat();
    transf.scale(3,3,3);
    transf.mul(*curr_mat, *curr_mat);
    
    transf.translate(-255,-95,-180);
    transf.mul(*curr_mat, *curr_mat);

    // Transform tree3
    curr_mat = _fract_tree3_tg -> getMat();
    transf.scale(3,3,3);
    transf.mul(*curr_mat, *curr_mat);

    transf.translate(-195,-95,-180);
    transf.mul(*curr_mat, *curr_mat);

    // roman ship
    curr_mat = _ship_roman_tg -> getMat ();
    transf.translate(200,0,-400);
    transf.mul(*curr_mat, *curr_mat);
    

    // setting up GLSL
    /*GLeeInit();
	if (GLEE_ARB_vertex_shader && GLEE_ARB_fragment_shader)
		printf("Ready for GLSL\n");
	else {
		printf("Not totally ready :( \n");
		exit(1);
	}*/
    toon = new Shader("in/toonf2.vert", "in/toonf2.frag");
  }


  // hw4's code
  /*
  // Texturing, and video texture
  else if ((_part == PART_TEXTURE) || (_part == PART_TEX_VIDEO_HORSE) ||
    (_part == PART_TEX_VIDEO))
  {
    if (_part == PART_TEXTURE)
      texImg = _ppmFile1.loadPPM ("in/ucsd_aerial.ppm", img_w, img_h);
    else if (_part == PART_TEX_VIDEO_HORSE)
    {
      texImg = _ppmFile1.loadPPM ("in/horse01_bin.ppm", img_w, img_h);
      NUM_FRMS_TTL = 12;
    }
    else if (_part == PART_TEX_VIDEO)
    {
      //cyl1.setRadius (3.0);
      //cyl1.setHeight (BasicMath::getPi() * 3.0);
      texImg = _ppmFile1.loadPPM ("in/sonic/sonic1.ppm", img_w, img_h);
      NUM_FRMS_TTL = 1291;
    }

    // Bind texture and set a bunch of properties
    loadTex (true);
  }
  */



  // Enable light sources
  light.enable ();
  light.enable (GL_LIGHT0);
  light.enable (GL_LIGHT1);
  light.enable (GL_LIGHT2);
  light.enable (GL_LIGHT3);

  light.setLitNum (GL_LIGHT1);
  light.setAmbient (0.2, 0.2, 0.2, 1.0);
  //light.setDiffuse (0.5, 0.0, 0.9, 1.0);  // mysterious purple / pink
  light.setDiffuse (0.6, 0.8, 0.0, 1.0);
  light.setSpec (1.0, 1.0, 1.0, 1.0);
  light.setPos (0.5, 1.5, -15, 1.0);
  light.setAttenConst (1.0);
  light.setAttenLin (0.0);
  light.setAttenQuad (0.0);
  light.setSpotDir (0, -1, 0);
  light.setSpotCut (75);

  //_world_tg -> addChild (&light);

  // bright point light
  light.setLitNum (GL_LIGHT2);
  light.setAmbient (0.4, 0.4, 0.0, 1.0);
  light.setDiffuse (0.4, 0.5, 0.0, 1.0);
  light.setSpec (0.0, 0.8, 0.0, 1.0);
  light.setPos (0.5, 1.5, -15, 1.0);

  // small spotlight shining on a ship - to show toon shading
  light.setLitNum (GL_LIGHT3);
  light.setAmbient (1.0, 0.0, 0.0, 1.0);
  light.setDiffuse (1.0, 0.0, 0.0, 1.0);
  light.setSpec (0.0, 0.8, 0.0, 1.0);
  light.setPos (0.5, 1.5, -200, 1.0);
  light.setSpotDir (0, -1, 0);
  light.setSpotCut (75);


  //_flashlight -> setSpotDir (0.5, -0.5, 0.0);  // partially working
//  light.setSpotDir (0.8, -0.3, 0.0);  // partially working
  //_flashlight -> setSpotDir (0.3, 0.0, -0.8);
  //_flashlight -> setSpotDir (0.0, 0.8, 0.0);  // alien-like
  //_flashlight -> setSpotDir (-0.5, 0.2, 0.0);
  //_flashlight -> setSpotDir (0.0, -0.5, -0.5);
//  light.setSpotCut (60.0);




  // Let normals be automatically adjusted to unit length after scale/shear
  //   - Mabel
  glEnable (GL_NORMALIZE);
  // set polygon drawing mode to fill front and back of each polygon
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  // set shading to smooth
  glShadeModel(GL_SMOOTH);
  glLightModelf (GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
  // This changes colors on objs
  //glEnable(GL_COLOR_MATERIAL);
  // Enable backface culling
  glEnable (GL_CULL_FACE);



  // Install callback functions:
  glutDisplayFunc(ourWindow::displayCB);
  glutReshapeFunc(ourWindow::reshapeCB);
  glutIdleFunc (ourWindow::idleCB);
  /* hw 5
  if ((_part == PART_SCENEGRAPH) || (_part == PART_LIGHT))
    glutIdleFunc (ourWindow::idleCB);
  */
  /* hw 4
  if (_part == PART_TEXTURE)
    glutIdleFunc (ourWindow::idleCB);
  else if ((_part == PART_TEX_VIDEO_HORSE) || (_part == PART_TEX_VIDEO))
    glutIdleFunc (ourWindow::idleCB_video);
  */
  glutKeyboardFunc (ourWindow::keyCB);
  // Special keys on board not covered by glutKeyboardFunc
  glutSpecialFunc (ourWindow::keyboardVelocityCB);
  // For trackball rotation. from hw 2
  glutMouseFunc (ourWindow::mouseRotCB);
  glutMotionFunc (ourWindow::mouseMotionCB);


  // hw4 code
  /*
  cyl1.getMatrix().identity();
  // Rotate, `.` cyl is drawn horizontally.
  cyl1.mulRotate (1,0,0,-90);
  if (_part == PART_TEX_VIDEO)
    //cyl1.mulTrans (0,_cyl_trans,0);
    cyl1.mulTrans (0,0,-5);
  */


  glutMainLoop();

  for (int i = 0; i < NUM_BEZ_OBJS; i++)
  {
    if (_verts_arr [i])
      delete [] _verts_arr [i];
    if (_triIndices_arr [i])
      delete [] (_triIndices_arr [i]);
    if (_norms_arr [i])
      delete [] _norms_arr [i];
    if (_texCoords_arr [i])
      delete [] _texCoords_arr [i];
  }

  return 0;
}


void usage (char * argv [])
{
  if (argv)
    fprintf (stderr, "%s\n", argv [0]);

  fprintf (stderr,
    "=== Mouse support: ===\n"
    "  Rightt click and drag: pan\n"
    "  (Left click and drag: trackball)\n"
    "\n"
    "=== Keyboard support: ===\n"
    "  Arrow keys - navigate\n"
    "    Up/Down: move foreward/backward\n"
    "    Left/Right: turn 1 degree to the left/right\n"
    "\n"
    "  l/L triggers and ends L-System input.\n"
    "    Enter L once to start input,\n"
    "      then enter a number to indicate # recursions to go,\n"
    "      then enter L again to end input.\n"
    "      L System will automatically redraw to the specified # recusions.\n"
    "\n"
    "  p/P triggers and ends Particle System input.\n"
    "    A/D: Decrease/increase spread\n"
    "    S/W: Decrease/increase number of particles\n"
    "\n"
    "  m - turn on/off environment map\n"
    "\n"
    "  t - turn on/off toon shading\n"
    "\n"
    "  g - the password to trigger glass pane open to the maps and ships room\n"
    "\n"
    "  u - display this Usage message to the terminal\n"
  );
}

void parseArgs (int argc, char * argv [])
{
  fprintf (stderr, "Parsing args...\n");

  for (int i = 0; i < argc; i++)
  {
    if (strcmp (argv[i], "-p") == 0)
    {
      // If already at last arg
      if (i+1 >= argc)
        fprintf (stderr, "No value specified, using default part.\n");
      else
      {
        _part = atoi (argv [i+1]);
        i++;
      }

      fprintf (stderr, "Set to part %d\n", _part);
    }


  }

}



// Set up ith Bezier curve
// Parameters:
//   num_curve: which curve to set up
//   ctrlpts_arr: float array storing the ctrl pts defined for ith curve
// Assumption:
//   Size of ctrlpts_arr == _num_ctrlpts [i].
void setupCurve (int num_curve, float * ctrlpts_arr)
{
  int num_ctrlpts = _num_ctrlpts[num_curve];

  // define an array of contrl pts in xy plane, i.e. (xi, yi, 0)
  //   need (_num_curves - 1) * 3 + 4 ctrl pts.
  for (int i = 0; i < num_ctrlpts; i ++)
  {
    _ctrlpts [num_curve] [i].setAll (ctrlpts_arr [2 * i],
      ctrlpts_arr [2 * i + 1], 0);
    _ctrlpts [num_curve] [i].mul (1.0/_OBJS_SCALE, _ctrlpts [num_curve] [i]);

    // Debug
    //_ctrlpts1 [i].print ();
  }

  Curve * curve = &(_curve [num_curve]);

  curve -> generate2DCurve (_num_curves[num_curve],
    _ctrlpts [num_curve], num_ctrlpts);

  // Test C1 continuity
  curve -> testC1Cont ();

  int num_samplepts = 14;//28;
  curve -> evalSamplePts (num_samplepts);
      
  curve -> rotateAroundY (_angle_inc [num_curve]);


  // Get outputs from curve generation fns
  vector <Vector3 *> * norms = _norms [num_curve],
    * verts = _verts [num_curve],
    * texCoords = _texCoords [num_curve];
  vector <int> * triIndices = _triIndices [num_curve];

  verts = curve -> getVerts ();
  triIndices = curve -> getTriIndices ();
  norms = curve -> getNormals ();
  texCoords = curve -> getTexCoords ();


  // Move vector<>s into arrays so can pass to Shape::doDraw ()
  //   Save sizes for call to doDraw() in displayCB().
  //   Free up memory from vectors.

  // Vertices
  _verts_arr [num_curve] = new float [(verts -> size ()) * 3];
  float * verts_arr = _verts_arr [num_curve];
  _verts_size [num_curve] = verts -> size ();
  int verts_size = _verts_size [num_curve];
  for (int i = 0; i < verts_size; i++)
  {
    verts_arr [3*i] = (*(verts -> at(i))) [0];
    verts_arr [3*i+1] = (*(verts -> at(i))) [1];
    verts_arr [3*i+2] = (*(verts -> at(i))) [2];
  }
  verts -> clear ();

  // Indices to vertices making triangles
  _triIndices_arr [num_curve] = new int [triIndices -> size()];
  int * triIndices_arr = _triIndices_arr [num_curve];
  _triIndices_size [num_curve] = triIndices -> size ();
  int triIndices_size = _triIndices_size [num_curve];
  for (int i = 0; i < triIndices_size; i++)
  {
    triIndices_arr [i] = triIndices -> at (i);
  }
  triIndices -> clear ();

  // Normals
  _norms_arr [num_curve] = new float [(norms -> size ()) * 3];
  float * norms_arr = _norms_arr [num_curve];
  for (int i = 0; i < norms -> size (); i++)
  {
    norms_arr [3*i] = (*(norms -> at (i))) [0];
    norms_arr [3*i+1] = (*(norms -> at (i))) [1];
    norms_arr [3*i+2] = (*(norms -> at (i))) [2];
  }
  norms -> clear ();

  // Texture coordinates
  _texCoords_arr [num_curve] = new float [(texCoords -> size()) * 3];
  float * texCoords_arr = _texCoords_arr [num_curve];
  for (int i = 0; i < texCoords -> size (); i++)
  {
    texCoords_arr [3*i] = (*(texCoords -> at(i))) [0];
    texCoords_arr [3*i+1] = (*(texCoords -> at(i))) [1];
    texCoords_arr [3*i+2] = (*(texCoords -> at(i))) [2];
  }
  texCoords -> clear ();

}



void loadTex (bool isFirstImg, int w, int h, GLuint& texName,
  unsigned char * texImg)
{
    glShadeModel (GL_FLAT);

    glGenTextures (1, &texName);
    glBindTexture (GL_TEXTURE_2D, texName);

    // Set wrap method to repeat
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    // Set to nearest neighbor method
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

    if (isFirstImg)
      glTexImage2D (GL_TEXTURE_2D, 0, GL_RGB, w, h, 0, GL_RGB,
        GL_UNSIGNED_BYTE, texImg);
    else
      // wrong params
      //glTexSubImage2D (GL_TEXTURE_2D, 0, GL_RGB, w, h, 0, GL_RGB,
      //  GL_UNSIGNED_BYTE, texImg);
      glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, w, h, GL_RGB,
        GL_UNSIGNED_BYTE, texImg);
}



// -------------------------------------------------------------- ourWindow --


// Callback method called when window is resized.
void ourWindow::reshapeCB(int w, int h)
{
  width = w;
  height = h;
  glViewport(0, 0, w, h);  // set new viewport size
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  if (_part == PART_MUSEUM)
  {
    // params: left, right, bottom, top, near, far
    //glFrustum(-10.0, 10.0, -10.0, 10.0, 10, 3000.0);
    //glFrustum(-100.0, 100.0, -100.0, 100.0, 10, 1000.0);
    gluPerspective (90.0f, (double) w / (double) h, 10.0, 3000.0);

  }

  /*
  // hw 5
  // set perspective projection viewing frustum
  if ((_part == PART_SCENEGRAPH) || (_part == PART_LIGHT))
    // params: left, right, bottom, top, near, far
    glFrustum(-10.0, 10.0, -10.0, 10.0, 10, 1000.0);

  // Use gluPerspective() and gluLookAt to set params so can use these params
  //   to calculate 6 frustum planes for culling
  else if (_part == PART_CULL)
  {
    gluPerspective (fov, ratio, near, far);
    gluLookAt (camPos[0], camPos[1], camPos[2],
      camLookat[0], camLookat[1], camLookat[2],
      camUp[0], camUp[1], camUp[2]);
  }
  */

  /*
  // hw 6
  else if (_part == PART_SCENE)
  {
    // params: left, right, bottom, top, -near, -far
    //   near and far must be positive. They look down the NEGATIVE z-axis.
    //   objs drawn btwn [-near, -far] down z-axis will be visible
    //glFrustum(-10.0, 10.0, -10.0, 10.0, 10, 1000.0);
    glFrustum(-10.0, 10.0, -10.0, 10.0, 10.0, 200.0);
  }
  */


}

// Callback method called when window readraw is necessary or
// when glutPostRedisplay() was called.
void ourWindow::displayCB(void)
{
  // Miliseconds. Start timing at beginning of the 10-frame period
  if (_num_frames == 0)
    _start_time = clock ();
  _num_frames ++;


  // Clear color and depth buffers
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  /*
  // Set material
  Material material = _material [0];
  material.reset ();
  //material.setAmbient (0.9, 0.0, 0.7, 1.0);  // mysterious purple
  material.setAmbient (0.9, 0.7, 0.0, 1.0);
  material.setDiffuse (0.9, 0.9, 0.4, 1.0);
  material.setSpec (0.0, 0.0, 0.0, 1.0);
  material.setShine (0);
  material.setMaterials ();
  */



  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();

  // Add in trackball to drawn geometry
  Matrix4 iden = Matrix4 ();
  //iden.translate (0, 0, 2);
  iden.mul (trackball_rotmat, iden);

  // Add in user movement
  iden.mul (_user_mov_mat, iden);

  // Change modelview mat to reflect that
  glMultMatrixd (iden.getPointer ());



//glutstrokestring ();


  // hw 7
  if (_part == PART_MUSEUM)
  {

    // Traverse scenegraph and draw all geometry
    if(shader_on == 1)
        toon->bind();
    else if(shader_on == -1)
        toon->unbind();
    // Draw all objs in scenegraph
    _world_tg -> draw_noCull (iden);


  }


  /*
  // hw 6
  if ((_part == PART_CURVE) || (_part == PART_SCENE))
  {

    float solidColor1 [] = {0.0, 1.0, 1.0};

    int last_term = 0;
    if (_part == PART_CURVE)
      last_term = 1;
    else if (_part == PART_SCENE)    *(objFilename) = 0;
    strcat (objFilename, "in/barrels.obj");
    _barrel = new Shape3D (SHAPE_OBJ, objFilename);


    _barrel_matr = new Material();
    _barrel_matr -> addChild (_barrel);
    _barrel_matr -> setAmbient (0.5, 0.5, 0.0, 1.0);
    _barrel_matr -> setDiffuse (0, .25, .60, 1.0);
    _barrel_matr -> setSpec (0.0, 0.0, 0.0, 1.0);
    _barrel_matr -> setShine (0);

    _barrel_tg = new TransformGroup();
    _barrel_tg -> setName ("barrel_TG");
    _barrel_tg -> addChild (_barrel_matr);
    _barrel_tg -> addChild (_barrel_tg);
    _room_tg -> addChild (_barrel_tg);

      last_term = NUM_BEZ_OBJS;
      //last_term = NUM_BEZ_OBJS - 1;  // uncomment to disable bg

    Matrix4 transf = Matrix4 ();

    // set up bezier curve _shapes for drawing
    for (int i = 0; i < last_term; i++)
    {
      if (_textureOn)
      {
        _shape [i].set_sg_textureOn (true);
        _shape [i].set_sg_texName (_texName [i]);

        _shape [i].setTexDim (_img_w[i], _img_h[i]);

        _shape [i].set_sg_nVerts (_verts_size [i]);
        _shape [i].set_sg_verts (_verts_arr [i]);
        _shape [i].set_sg_nIndices (_triIndices_size [i]);
        _shape [i].set_sg_indices (_triIndices_arr [i]);
        _shape [i].set_sg_colors (NULL);
        _shape [i].set_sg_solidColor (solidColor1);
        _shape [i].set_sg_normals (_norms_arr [i]);
        _shape [i].set_sg_texCoords (_texCoords_arr [i]);


        // Without scene graph, draw it by these calls
        // Set texture
        //glEnable (GL_TEXTURE_2D);
        //glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
        //glBindTexture (GL_TEXTURE_2D, _texName [i]);
        //_shape[i].doDraw (_verts_size [i], _verts_arr [i], _triIndices_size [i],
        //  _triIndices_arr [i], NULL, solidColor1, _norms_arr [i],
        //  // If turn off normal, just pass in verts array
        //  //triIndices_arr [i], NULL, solidColor, _verts_arr [i],
        //  _texCoords_arr [i]);
      }

      // Texture off
      else
      {
        _shape [i].set_sg_textureOn (false);

        _shape [i].set_sg_nVerts (_verts_size [i]);
        _shape [i].set_sg_verts (_verts_arr [i]);
        _shape [i].set_sg_nIndices (_triIndices_size [i]);
        _shape [i].set_sg_indices (_triIndices_arr [i]);
        _shape [i].set_sg_colors (NULL);
        _shape [i].set_sg_solidColor (solidColor1);
        _shape [i].set_sg_normals (_norms_arr [i]);
        _shape [i].set_sg_texCoords (NULL);


        // Without scene graph, draw it by these calls
        //glDisable (GL_TEXTURE_2D);
        // Turn off texture
        //_shape[i].doDraw (_verts_size [i], _verts_arr [i], _triIndices_size [i],
        //  _triIndices_arr [i], NULL, solidColor1, _norms_arr [i], NULL);
        //  // If turn off normal, just pass in verts array
        //  //triIndices_arr [i], NULL, solidColor, _verts_arr [i], NULL);
      }
    }

    // Traverse scenegraph and draw all geometry
    // Draw all objs in scenegraph
    _world_tg -> draw_noCull (iden);


  }

  // hw 6 extra credit
  else if (_part == PART_PATCH)
  {

      float solidColor [] = {0.0, 1.0, 1.0};

      // Set texture
      glEnable (GL_TEXTURE_2D);
      glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
      glBindTexture (GL_TEXTURE_2D, _flag_texName);

      _flag_shape.doDraw (_flag_verts_size, _flag_verts_arr,
        _flag_triIndices_size,
        //_triIndices_arr, NULL, solidColor1, _norms_arr,
        // If turn off normal, just pass in verts array
        _flag_triIndices_arr, NULL, solidColor, _flag_verts_arr,
        // use this if have textures
        //_texCoords_arr);
        NULL);

  }
  */

  /*
  // hw 5
  if ((_part == PART_SCENEGRAPH) || (_part == PART_LIGHT))
    _world_tg -> draw_noCull (iden);

  // hw 5
  else if (_part == PART_CULL)
  {
    if (cullIsOn)
    {
      // calc 6 frustum planes for culling
      calcFrustumPlanes ();

      // Recursively traverse scenegraph
      _world_tg -> draw (iden);
    }

    else
      _world_tg -> draw_noCull (iden);
  }
  */


  // Debug
  // Draw all the ctrl pts defining the curve.
  /*
  glBegin (GL_LINES);
    glVertex3f (_ctrlpts1 [0][0], _ctrlpts1 [0][1], 0);
    glVertex3f (_ctrlpts1 [1][0], _ctrlpts1 [1][1], 0);
    glVertex3f (_ctrlpts1 [1][0], _ctrlpts1 [1][1], 0);
    glVertex3f (_ctrlpts1 [2][0], _ctrlpts1 [2][1], 0);
    glVertex3f (_ctrlpts1 [2][0], _ctrlpts1 [2][1], 0);
    glVertex3f (_ctrlpts1 [3][0], _ctrlpts1 [3][1], 0);
    glVertex3f (_ctrlpts1 [3][0], _ctrlpts1 [3][1], 0);
    glVertex3f (_ctrlpts1 [4][0], _ctrlpts1 [4][1], 0);
    glVertex3f (_ctrlpts1 [4][0], _ctrlpts1 [4][1], 0);
    glVertex3f (_ctrlpts1 [5][0], _ctrlpts1 [5][1], 0);
    glVertex3f (_ctrlpts1 [5][0], _ctrlpts1 [5][1], 0);
    glVertex3f (_ctrlpts1 [6][0], _ctrlpts1 [6][1], 0);
  glEnd ();
  */






  //fprintf (stderr, "displayCB(): done recursive call root.draw().\n");

  // 1 frame. Miliseconds, so mult 1000000 
  _end_time = clock ();
  double fps = 1.0 / ((double) _end_time - (double) _start_time) * 1000000;
  //fprintf (stderr, "Average FPS in last %d frames: %f.\n", _num_frames, fps);
  _num_frames = 0;

  

  /*
  // Calc frame rate. Average every 10 frames
  if (_num_frames >= 10)
  {
    _end_time = time (NULL);
    float fps = (float) _num_frames / (float) (_end_time - _start_time);
fprintf (stderr, "_start_time %ld\n", _start_time);
fprintf (stderr, "_end_time %ld\n", _end_time);
    fprintf (stderr, "Average FPS in last %d frames: %f.\n", _num_frames, fps);
    //fprintf (stderr, "Time this frame: %f.\n", _end_time - _start_time);

    // after use, reset for next 10-frame measurement round
    _num_frames = 0;
  }
 */


  /*
  // hw 4
  glMatrixMode(GL_MODELVIEW);

  if ((_part == PART_LIGHTING) || (_part == PART_SHADER))
  {
    // Sphere 1

    glLoadIdentity();

    // Set lighting
    light.setLitNum (GL_LIGHT0);
    light.setAmbient (0.2, 0.2, 0.2, 1.0);
    //light.setAmbient (0.9, 0.7, 0.0, 1.0);
    //light.setDiffuse (0.0, 1.0, 1.0, 1.0);
    //light.setDiffuse (1.0, 0.9, 0.0, 1.0); // yoke yellow
    light.setDiffuse (0.5, 0.0, 0.9, 1.0);
    light.setSpec (1.0, 1.0, 1.0, 1.0);
    glMultMatrixd (trackball_rotmat.getPointer ());
    //light.setPos (1.0, 2.0, 3.0, 1.0);
    light.setPos (-10.0, 5.0, 3.0, 1.0);
    light.setAttenConst (1.0);
    light.setAttenLin (0.0);
    light.setAttenQuad (0.0);

    // Set material
    glLoadIdentity ();
    material.reset ();
    //material.setAmbient (0.9, 0.7, 0.0, 1.0);
    material.setAmbient (0.9, 0.0, 0.9, 1.0);
    material.setDiffuse (0.9, 0.9, 0.4, 1.0);
    material.setSpec (0.0, 0.0, 0.0, 1.0);
    material.setShine (0);
    material.setMaterials ();

    // set cam position
    glTranslatef(0, 0, -20);
    sphere1mat.translate(-8.0, 0, 0);
    glMultMatrixd(sphere1mat.getPointer());

    // Draw sphere
    // Apply shader prgms

    if ((_part == PART_SHADER) && (shader_on))// && (light1_on))
    {
      //fprintf (stderr, "shader1 binding.\n");
      if (light1_on)
        shader1 -> bind ();
      else if (light2_on)
        shader2 -> bind ();
    }

    // Switch to a finer tessellation for debugging to see the fixed function
    //   lighting.
    //glutSolidSphere(6.0, 120, 120);
    glutSolidSphere(6.0, 12, 12); 


    // Sphere 2  

    // done with this object, clear the modelview matrix
    glLoadIdentity();


    // Set lighting
    light.setLitNum (GL_LIGHT1);
    light.setAmbient (0.0, 1.0, 0.0, 1.0);
    light.setDiffuse (0.0, 1.0, 1.0, 1.0);
    light.setSpec (0.0, 1.0, 1.0, 1.0);
    light.setPos (1.0, 2.0, 3.0, 1.0);
    light.setSpotDir (0.4, -0.1, -1.0);
    light.setSpotCut (10.0);


    // Set material
    material.reset ();
    material.setAmbient (0.9, 0.7, 0.0, 1.0);
    material.setDiffuse (0.9, 0.9, 0.4, 1.0);
    //material.setSpec (0.0, 0.0, 0.0, 1.0);
    material.setSpec (0.9, 0.9, 0.9, 1.0);
    material.setShine (100);
    material.setMaterials ();

    // Set cam position again since we just cleared everything
    glTranslatef(0, 0, -20);
    sphere2mat.translate(8.0, 0, 0);
    glMultMatrixd(sphere2mat.getPointer());

    // Draw sphere
     
    // Switch to a finer tessellation for debugging to see the fixed function
    //   lighting
    //glutSolidSphere(6.0, 120, 120);
    glutSolidSphere(6.0, 12, 12); 

    if ((_part == PART_SHADER) && (shader_on))// && (light2_on))
    {
      //fprintf (stderr, "shader2 unbinding.\n");
      if (light1_on)
        shader1 -> unbind ();
      else if (light2_on)
        shader2 -> unbind ();
    }
  }

  // Texture on cylinder
  else if ((_part == PART_TEXTURE) || (_part == PART_TEX_VIDEO_HORSE) ||
    (_part == PART_TEX_VIDEO))
  {
    glLoadIdentity();
 
    // Set lighting
    light.setLitNum (GL_LIGHT2);
    light.setAmbient (0.0, 1.0, 0.0, 1.0);
    light.setDiffuse (0.0, 1.0, 1.0, 1.0);
    light.setSpec (0.0, 1.0, 1.0, 1.0);
    light.setPos (1.0, 2.0, 3.0, 1.0);
    light.setSpotDir (0.4, -0.1, -1.0);
    light.setSpotCut (10.0);

    // set cam position
    glTranslatef(0, 0, -12);
    glMultMatrixd (cyl1.getMatrix().getPointer());
    glMultMatrixd (trackball_rotmat.getPointer ());

    // Set texture
    glEnable (GL_TEXTURE_2D);
    glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
    glBindTexture (GL_TEXTURE_2D, texName);

    cyl1.setTexDim (img_w, img_h);
    // set doTexture flag to true so drawCirc() in shape.cpp can see it and
    //   calc the texture coords and call glTexCoord2f() before glVertex3f().
    cyl1.setTex (true);

    // Draw cylinder, along with the texture
    cyl1.draw ();

    glFlush ();
    glDisable (GL_TEXTURE_2D);
  }
  */


  glutSwapBuffers();
}



void ourWindow::idleCB (void)
{
  // If glass door needs to open, and if have not opened till limit yet, then
  //   play open animation
  if ((_glass1_openOn) && (_glass1_openCurrZ > _glass1_openLimitZ))
  {
    _glass1_tg -> mulTranslate (0.0, 0.0, _glass1_openIncZ);
    _glass1_openCurrZ += _glass1_openIncZ;
  }

  glutPostRedisplay ();
}


/*
void ourWindow::idleCB (void)
{
  if (! robotIsInited)
  {
    //fprintf (stderr, "Robot has not been initialized.\n");
    return;
  }

  float deg = 0;
  Vector3 pivot_offset = Vector3 (), rot_axis = Vector3 ();
  int num_frames = 360;
  Matrix4 * tmp = NULL;
  double x = 0.0, y = 0.0, z = 0.0;

  // entire robot

  deg = 360.0 / num_frames / 10;
  rot_axis.setAll (0,1,0);
  float curr_deg_robot = 0.0f;
  bool robot_isFw = true;
  moveLimb (_robot_tg, 0, 360, deg, curr_deg_robot,
    pivot_offset, rot_axis, robot_isFw);



  // arms

  // arm shoulder
  deg = (fabs (deg_armU_end - deg_armU_start)) / num_frames;
  rot_axis.setAll (1,0,0);
  pivot_offset.setAll (0,-armULen/2,0);
  // left
  if (_part != PART_LIGHT)
    moveLimb (_armL_tg, deg_armU_start, deg_armU_end, deg, _curr_deg_armLU,
      pivot_offset, rot_axis, _curr_armLU_isFw);
  // right
  moveLimb (_armR_tg, deg_armU_start, deg_armU_end, deg, _curr_deg_armRU,
    pivot_offset, rot_axis, _curr_armRU_isFw);

  // arm Lower
  deg = (fabs (deg_armL_end - deg_armL_start)) / num_frames;
  rot_axis.setAll (1,0,0);
  tmp = _armLL_tg -> getMat ();
  x = tmp -> get (12);
  //double y = tmp -> get (13)+5-armLLen/2;
  y = tmp -> get (13);
  z = tmp -> get (14);
  pivot_offset.setAll (-x,-y-armLLen/2,-z);
  // left
  //if (_part != PART_LIGHT)
    moveLimb (_armLL_tg, deg_armL_start, deg_armL_end, deg, _curr_deg_armLL,
      pivot_offset, rot_axis, _curr_armLL_isFw);
  // right
  moveLimb (_armRL_tg, deg_armL_start, deg_armL_end, deg, _curr_deg_armRL,
    pivot_offset, rot_axis, _curr_armRL_isFw);

  // hands
  rot_axis.setAll (0,1,0);
  pivot_offset.setAll (0,0.75,0);
  // Set params so that hand just keeps spinning. No sense of forward or back
  float curr_deg_hand = 0.0f;
  bool hand_isFw = true;
  // left
  if (_part != PART_LIGHT)
    moveLimb (_handL_tg, 0.0, 360.0, 1.0, curr_deg_hand, pivot_offset, rot_axis,
      hand_isFw);
  // right
  moveLimb (_handR_tg, 0.0, 360.0, 1.0, curr_deg_hand, pivot_offset, rot_axis,
    hand_isFw);


  // legs

  // leg hips
  deg = (fabs (deg_legU_end - deg_legU_start)) / num_frames;
  rot_axis.setAll (1,0,0);
  pivot_offset.setAll (0,-legULen/2+6,0);
  // left
  moveLimb (_legL_tg, deg_legU_start, deg_legU_end, deg, _curr_deg_legLU,
    pivot_offset, rot_axis, _curr_legLU_isFw);
  // right
  moveLimb (_legR_tg, deg_legU_start, deg_legU_end, deg, _curr_deg_legRU,
    pivot_offset, rot_axis, _curr_legRU_isFw);

  // leg Lower
  deg = (fabs (deg_legL_end - deg_legL_start)) / num_frames;
  rot_axis.setAll (1,0,0);
  tmp = _legLL_tg -> getMat ();
  x = tmp -> get (12);
  //double y = tmp -> get (13)+5-legLLen/2;
  y = tmp -> get (13);
  z = tmp -> get (14);
  pivot_offset.setAll (-x,-y-legLLen/2+6,-z);
  // left
  moveLimb (_legLLgrp_tg, deg_legL_start, deg_legL_end, deg, _curr_deg_legLL,
    pivot_offset, rot_axis, _curr_legLL_isFw);
  // right
  moveLimb (_legRLgrp_tg, deg_legL_start, deg_legL_end, deg, _curr_deg_legRL,
    pivot_offset, rot_axis, _curr_legRL_isFw);

  // feet
  deg = (fabs (deg_foot_end - deg_foot_start)) / num_frames;
  rot_axis.setAll (1,0,0);
  pivot_offset.setAll (0,legLLen/2,0);
  // left
  moveLimb (_footL_tg, deg_foot_start, deg_foot_end, deg, _curr_deg_footL,
    pivot_offset, rot_axis, _curr_footL_isFw);
  // right
  moveLimb (_footR_tg, deg_foot_start, deg_foot_end, deg, _curr_deg_footR,
    pivot_offset, rot_axis, _curr_footR_isFw);



  glutPostRedisplay ();
}
*/

// Move limbs of robot to look like it's walking.
//   Uses translate-rotate-translate to rotate wrt a non-origin pivot.
// Parameter:
//   limb_tg: TransformGroup of the limb to rotate
//   deg_start, deg_end: range of rotation, from deg_start to deg_end, where
//     the normal pose (straight down) is 0 degrees.
//   deg: # degrees to move each round.
//   curr_deg: current degree of the limb. Used to determine if rotating past
//     _start or _end so can flip the direction when reach end of rotatn range.
//   pivot_offset: rotation pivot's offset from origin, i.e. vector needed
//     to move pivot pt to origin before rotation.
//   isFw: is the limb currently moving forward (true) or backward (false)
void ourWindow::moveLimb (TransformGroup * limb_tg,
  const float deg_start, const float deg_end, float deg, float& curr_deg,
  Vector3& pivot_offset, Vector3& rot_axis, bool& isFw)
{
  float x = pivot_offset [0], y = pivot_offset [1], z = pivot_offset [2];

  // Translate back to origin, translate more to move rotation pivot (on
  //   top edge of arm) to origin
  limb_tg -> mulTranslate (x,y,z);

  // Decide degree to rotate
  // If going forward, go +1 degrees
  if (isFw)
  {
    // If swinging forward past the end, flip (to go backwards)
    if (curr_deg >= deg_end)
    {
      isFw = false;
      deg = -deg;
    }
  }

  // If going backward, go -1 degrees
  else
  {
    deg = -deg;
    // If swinging backward past the beginning, flip (to go forward)
    if (curr_deg <= deg_start)
    {
      isFw = true;
      deg = -deg;
    }
  }

  // Rotate wrt pivot, which has been moved to origin
  limb_tg -> mulRotate (rot_axis[0], rot_axis[1], rot_axis[2], deg);
  // Increment # degrees rotated this round
  curr_deg += deg;

  // Translate back to place
  limb_tg -> mulTranslate (-x,-y,-z);
}


// hw4 code
/*
void ourWindow::idleCB (void)
{
  // by z, `.` cyl is already rotated 90 degrees wrt x to display vertically,
  //   `.` cyl is drawn horizontally. In cyl's local coordinates, the axis
  //   going through its 2 bases is the z axis.
  cyl1.mulRotate (0,0,1,0.1);

  // TEST memory deletion
  //_ppmFile1.deleteData (texImg);
  //texImg = _ppmFile1.loadPPM ("in/ucsd_aerial.ppm", img_w, img_h);
  //fprintf (stderr, "reloading...\n");

  glutPostRedisplay ();
}


void ourWindow::idleCB_video (void)
{

  // Load new frame
  char filename [PATH_MAX];
  *(filename) = 0;
  char frame_str [80];
  *(frame_str) = 0;

  if (_part == PART_TEX_VIDEO_HORSE)
  {
    strcat (filename, "in/horse");
    sprintf (frame_str, "%02d", (int) frame_num);
    strcat (filename, frame_str);
    strcat (filename, "_bin.ppm");

    _ppmFile1.deleteData (texImg);
    texImg = _ppmFile1.loadPPM (filename, img_w, img_h);
  }
  else if (_part == PART_TEX_VIDEO)
  {
    // Sampled every 10 frames, else too many images, over quota. then frames
    //   too fast. So only load every 10 frames.
    if ((int) frame_num % 10 == 1)
    {
      strcat (filename, "in/sonic/sonic");
      sprintf (frame_str, "%d", (int) frame_num);
      strcat (filename, frame_str);
      strcat (filename, ".ppm");
      // Debug
      //fprintf (stderr, "file: %s\n", filename);

      _ppmFile1.deleteData (texImg);
      texImg = _ppmFile1.loadPPM (filename, img_w, img_h);
    }
  }

  //loadTex (false);
  glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, img_w, img_h, GL_RGB,
    GL_UNSIGNED_BYTE, texImg);

  // Update frame number. If this is last frame, go back to 1st frame. Else
  //   increment normally to next frame.
  if (frame_num >= NUM_FRMS_TTL)
    frame_num = 1;
  else
  {
    if (_part == PART_TEX_VIDEO_HORSE)
      frame_num ++;
    else if (_part == PART_TEX_VIDEO)
      //frame_num += 10;
      frame_num += 1;
  }

  if (_part == PART_TEX_VIDEO_HORSE)
    cyl1.mulRotate (0,0,1,1);
  else if (_part == PART_TEX_VIDEO)
  {
    cyl1.mulRotate (0,0,1,1);
  }

  // Do the same for rotating cylinder slowly and call displayCB
  glutPostRedisplay ();
}
*/
bool envMapOnOff = true;

void ourWindow::keyCB (unsigned char key, int, int)
{
  // If waiting for user to enter lsys # recursions
  if (lsysAcceptInput >= 0)
  {
    // Get # recursions entered
    switch (key)
    {
      // When enter L again, indicates end of entering
      case 'l':
      case 'L':
        // Clear flag
        lsysAcceptInput = -1;

        // Convert string into a number
        lsysNumRecur = atoi (lsysNumRecurStr);

        // Set # recursions, redraw
        if (lsysNumRecur > 0)
        {
          _lsys1 -> setNumRecur (lsysNumRecur);
          fprintf (stderr, " Drawing...\n", key);

          // Redo display list
          _lsys1 -> setDispListCompiled (false);

          glutPostRedisplay ();
        }
        else
          fprintf (stderr, "Invalid number (atoi() returned 0).\n");

        break;

      // All other keys, accept as if they're numbers
      default:
        fprintf (stderr, "%c", key);

        // If just starting the take input, clear string
        if (lsysAcceptInput == 0)
          *lsysNumRecurStr = 0;

        // Concat entered char to string (will convert whole str to int later)
        sprintf (lsysNumRecurChr, "%c", key);
        strcat (lsysNumRecurStr, lsysNumRecurChr);

        // Inc flag. Actual value not used, just so that it's not 0
        //   (which indicates need to clear string).
        lsysAcceptInput ++;

        break;
    }

    // Skip the other switch-case statement below that aren't for lsys
    return;
  }

  // If waiting input for particle system
  if (psysAcceptInput >= 0)
  {
    // Use a w s d as keyboard left up down right keys
    switch (key)
    {
      // End input session
      case 'p':
      case 'P':
        fprintf (stderr, "Ending particle system input.\n");
        psysAcceptInput = -1;
        break;

      // left
      case 'a':
      case 'A':
        fprintf (stderr, "Decreasing spread of particles...\n");
        _psys1 -> decreaseSpray ();
        break;

      // right
      case 'd':
      case 'D':
        fprintf (stderr, "Increasing spread of particles...\n");
        _psys1 -> increaseSpray ();
        break;

      // down
      case 's':
      case 'S':
        fprintf (stderr, "Decreasing # particles...\n");
        _psys1 -> decreaseNumParticles ();
        break;

      // up
      case 'w':
      case 'W':
        fprintf (stderr, "Increasing # particles...\n");
        _psys1 -> increaseNumParticles ();
        break;

      default:
        break;
    }

    glutPostRedisplay ();
  }

  switch (key)
  {
    // hw 7

    // L System input trigger
    case 'l':
    case 'L':
      fprintf (stderr, "Accepting L-System recursion #: ");
      lsysAcceptInput = 0;
      break;

    // Particle System input trigger
    case 'p':
    case 'P':
      fprintf (stderr, "Accepting Particle System input: ");
      psysAcceptInput = 0;
      break;

    // Print Usage msg
    case 'u':
    case 'U':
      usage ();
      break;

    // full screen mode
    case 'f':
    case 'F':
      glutGameModeString ("640x480:16@60");
      glutEnterGameMode ();
      //glutGameModeString ("1024x768:32@65");
      //glutEnterGameMode ();
      break;

    // glass open after password
    case 'g':
    case 'G':
      _glass1_openOn = ! _glass1_openOn;
      // When toggle off, turn off
      if (! _glass1_openOn)
        _glass1_openCurrZ = 0.0f;
      break;

    // enable toon shading
    case 't':
    case 'T':
      printf("Switching toon shading\n");
      shader_on = shader_on*-1;
      break;
	case 'm':
    case 'M':
    if(envMapOnOff)
    {
      envMapOnOff = false;
      _chain1 -> set_sg_envMapOn(envMapOnOff);
      _globe -> set_sg_envMapOn(envMapOnOff);
      _david -> set_sg_envMapOn(envMapOnOff);
    }
    else
    {
      envMapOnOff = true;
      _chain1 -> set_sg_envMapOn(envMapOnOff);
      _globe -> set_sg_envMapOn(envMapOnOff);
      _david -> set_sg_envMapOn(envMapOnOff);
    }
    break;
    /* hw 6
    case 't':
      fprintf (stderr, "Texture on.\n");
      _textureOn = true;
      glutPostRedisplay ();
      break;
    case 'r':
      fprintf (stderr, "Texture off.\n");
      _textureOn = false;
      glutPostRedisplay ();
      break;
    */

    /* hw 5
    // no culling
    case 'n':
      fprintf (stderr, "Culling off.\n");
      cullIsOn = false;
      displayCB();
      break;

    // culling on
    case 'c':
      fprintf (stderr, "Culling on.\n");
      cullIsOn = true;
      displayCB();
      break;
    */


    // hw4 code
    /*
    // Toggle point light
    case 'p':
      light1_on = light.toggle (GL_LIGHT0);
      fprintf (stderr, "Point light %s.\n", light1_on ?"on" : "off");
      glutPostRedisplay ();
      break;

    // Toggle spot light
    case 's':
      light2_on = light.toggle (GL_LIGHT1);
      fprintf (stderr, "Spot light %s.\n", light2_on ?"on" : "off");
      glutPostRedisplay ();
      break;

    // Toggle GLSL per-pixel shader
    case 'g':
      if (_part == PART_SHADER)
      {
        shader_on = !shader_on;
        fprintf (stderr, "GLSL per-pixel shader %s.\n", shader_on ?"on":"off");
        glutPostRedisplay ();
      }
      break;
    */

    default:
      break;
  }

}

// Enable speedup slowdowns of flight simulation by keyboard
void ourWindow::keyboardVelocityCB (int key, int x, int y)
{
  Matrix4 transf = Matrix4 ();
  float rotDeg = 0.0f;

  // When up and down keys are pressed, change velocity of flight
  switch (key)
  {
    case GLUT_KEY_UP:
      //fprintf (stderr, "Walking foreward\n");

      // Make a movement matrix
      // Update movement mat. this mat will mul by MODELVIEW in display()
      transf.translate (0, 0, 10);
      transf.mul (_user_mov_mat, _user_mov_mat);

      glutPostRedisplay ();
      break;

    case GLUT_KEY_DOWN:
      //fprintf (stderr, "Walking backward\n");
      transf.translate (0, 0, -10);
      transf.mul (_user_mov_mat, _user_mov_mat);
      glutPostRedisplay ();
      break;

    case GLUT_KEY_LEFT:
      //fprintf (stderr, "Walking to left\n");
      rotDeg = -5.0f;
      transf.rotate (0, 1, 0, rotDeg);
      transf.mul (_user_mov_mat, _user_mov_mat);
      // for particle sys billboarding
      if (_psys1) _psys1 -> setYaw (rotDeg);
      glutPostRedisplay ();
      break;

    case GLUT_KEY_RIGHT:
      //fprintf (stderr, "Walking to right\n");
      rotDeg = 5.0f;
      transf.rotate (0, 1, 0, rotDeg);
      transf.mul (_user_mov_mat, _user_mov_mat);
      // for particle sys billboarding
      if (_psys1) _psys1 -> setYaw (rotDeg);
      glutPostRedisplay ();
      break;

    /* hw 1
    // Speed up. Increase velocity.
    case GLUT_KEY_UP:
      ter_velo += 0.3f;
      fprintf (stderr, "Speeding up... current velo factor %f\n", ter_velo);
      break;

    // Slow down. Decrease velocity.
    case GLUT_KEY_DOWN:
      ter_velo -= 0.3f;
      if (ter_velo < 0)
        ter_velo = 0.0;
      fprintf (stderr, "Slowing down... current velo factor %f\n", ter_velo);
      break;
    */

    case GLUT_KEY_F1:
      fprintf (stderr, "F1 (Quit key) pressed. Come again :)\n");
      glutLeaveGameMode ();
      exit (0);

    default:
      break;
  }
}


// Trackball functionality from hw 2
// Save "previous pt" at mouse down.
// Parameters:
//   button: GLUT_LEFT_BUTTON, GLUT_MIDDLE_BUTTON, or GLUT_RIGHT_BUTTON
//   state: GLUT_UP or GLUT_DOWN
void ourWindow::mouseRotCB (int button, int state, int x, int y)
{ 
  if (button == GLUT_LEFT_BUTTON)
  {
    if (state == GLUT_DOWN)
    {
      saveMouseRot (x, y, false);
      _mouse_left_down = true;
    }
    else
      _mouse_left_down = false;
  }

  else if (button == GLUT_RIGHT_BUTTON)
  {
    if (state == GLUT_DOWN)
    {
      saveMousePan (x, y, false);
      _mouse_right_down = true;
    }
    else
      _mouse_right_down = false;
  }

} 
  

// Mouse callback function. Perform scene rotation when see mouse motion.
void ourWindow::mouseMotionCB (int x, int y)
{
  if (_mouse_left_down)
    saveMouseRot (x, y, true);

  // doing a "if" would allow both buttons be pressed at same time. else left
  //   has priority, if use "else-if"
  if (_mouse_right_down)
    saveMousePan (x, y, true);
}


// Parameters:
//   doAction: true if actually want to pan/rotate, happens when there IS mouse
//     motion. false if just want to save point, when mouse is just pressed.
void ourWindow::saveMouseRot (int curr_x, int curr_y, bool doAction)
{
  // See window as 2x2 coords. Make sure these are floats. If int, won't work!
  //   If int, will always be rotating 90 degrees and won't be right!
  //float minSideLen = min (width, height) / 2.0f;
  //float x_trans = curr_x / (minSideLen);
  //float y_trans = curr_y / (minSideLen);
  float x_trans = curr_x / (width / 2.0f), y_trans = curr_y / (height / 2.0f);

  // Translate from upper-left-origin coord sys to mid-origin coord sys.
  //   Move x down 1 unit, move y down 1 unit, and flip y so that positive-y
  //   axis points up (as opposed to pointing down in the upper-left-origin
  //   coord sys).
  //   New coord sys is [-1, 1] in both x and y, old coord sys is [0,0] to
  //   [2,2] in both x and y.
  x_trans = x_trans - 1.0f;
  y_trans = - y_trans + 1.0f;

  // Calc z-coord from x and y coords, so can get the (x,y,z) pt that mouse
  //   touches on the virtual sphere of the trackball.
  //   Use sphere eqn x^2 + y^2 + z^2 = 1 for unit sphere.
  //float z2_trans = 1 - x_trans*x_trans - y_trans*y_trans;
  // Slightly bigger sphere
  float z2_trans = 4 - x_trans*x_trans - y_trans*y_trans;
  // TODO: for the "ELSE" statement, don't use 0. We'll need to implement a 
  //   rotation wrt z-axis, for mouse pos that are outside the sphere!
  // RE: wait... this works already. don't need to change anything
  //float z_trans = (z2_trans > 0) ? (float) sqrt (z2_trans) : 0.0;
  float z_trans = 0.0;
  if (z2_trans > 0.0)
    z_trans = (float) sqrt (z2_trans);
  else
  {
    z_trans = 0.0f;
    x_trans = (x_trans) / (sqrt (x_trans * x_trans + y_trans * y_trans));
    y_trans = (y_trans) / (sqrt (x_trans * x_trans + y_trans * y_trans));
  }

  //fprintf (stderr, "z_trans <= 0\n");

  // Debug
  //fprintf (stderr, "x_trans %f y_trans %f z2_trans %f z_trans %f\n",
  //  x_trans, y_trans, z2_trans, z_trans);

  Vector3 curr_pt = Vector3 (x_trans, y_trans, z_trans);
  curr_pt.norm (curr_pt);

  if (doAction)
    calcMouseRot (curr_x, curr_y, curr_pt);

  // Save this pos for next mouse motion calculations
  prev_pt_rot.set (0, curr_pt [0]);
  prev_pt_rot.set (1, curr_pt [1]);
  prev_pt_rot.set (2, curr_pt [2]);

}
   
// For mouse guided rotations of objects
void ourWindow::calcMouseRot (int curr_x, int curr_y, Vector3& curr_pt)
{
  // Use this pt and prev pt on sphere as 2 vectors (as opposed to pts), calc
  //   rotation axis and degree required to rotate sphere from prev pt to curr
  //   pt.
  // Axis = cross prod, radians = acos (dot prod / (mag1 * mag2)).
  Vector3 rot_axis = Vector3 ();
  prev_pt_rot.cross (curr_pt, rot_axis);

  // Debug
  //fprintf (stderr, "prev_pt_rot (%f %f %f) \n",
  //  prev_pt_rot [0], prev_pt_rot [1], prev_pt_rot [2]);
  //fprintf (stderr, "curr_pt (%f %f %f) \n",
  //  curr_pt [0], curr_pt [1], curr_pt [2]);

  float radians = acos (prev_pt_rot.dot (curr_pt) /
    (prev_pt_rot.len () * curr_pt.len ()));
  
  // Debug
  //fprintf (stderr, 
  //  "rot_axis (%f %f %f) radian %f\n",
  //  rot_axis [0], rot_axis [1], rot_axis [2], radians);
  

  // Make a rot mat of this rotatn wrt arbitrary axis
  // For PGM terrain flight simulation, map should move to oppo dir of mouse
  //   so we travel in the mouse dir.
  Matrix4 rot_mat = Matrix4 ();
  rot_mat.rotate (rot_axis [0], rot_axis [1], rot_axis [2],
    ter_velo * BasicMath::degree (radians));

  // Update rot mat with this new rotation
  rot_mat.mul (trackball_rotmat, trackball_rotmat);

  // Debug
  //trackball_rotmat.print ();

  // Update picture
  glutPostRedisplay ();
  
/*
  if (mode == MODE_HOUSE)
  {
    house.mulRotate (rot_axis [0], rot_axis [1], rot_axis [2],
      ter_velo * BasicMath::degree (radians));
  }
  else if (mode == MODE_OBJ)
  {
    objFile1.mulRotate (rot_axis [0], rot_axis [1], rot_axis [2],
      ter_velo * BasicMath::degree (radians));
  }
  // Mult this mat by GL_ mat
  else if (mode == MODE_PGM)
  {
*/

//    glMatrixMode (GL_MODELVIEW);
//    glMultMatrixd ((GLdouble *) rot_mat.getPointer ());

//  }

}

void ourWindow::saveMousePan (int curr_x, int curr_y, bool doAction)
{
  // Panning

  Vector3 curr_pt = Vector3 (curr_x, curr_y, 0);

  if (doAction)
    calcMousePan (curr_x, curr_y, curr_pt);

  // Save this pos for next mouse motion calculations
  prev_pt_pan.set (0, curr_pt [0]);
  prev_pt_pan.set (1, curr_pt [1]);
  prev_pt_pan.set (2, curr_pt [2]);


  //if (_psys1)
  //  _psys1 -> setYaw ((curr_x - 300) / 3.0f);
  /*
  // Particle systems billboarding
  // Use trackball algorithm to calculate the angle rotated by panning

  // See window as 2x2 coords. Make sure these are floats. If int, won't work!
  //   If int, will always be rotating 90 degrees and won't be right!
  //float minSideLen = min (width, height) / 2.0f;
  //float x_trans = curr_x / (minSideLen);
  //float y_trans = curr_y / (minSideLen);
  float x_trans = curr_x / (width / 2.0f), y_trans = curr_y / (height / 2.0f);

  // Translate from upper-left-origin coord sys to mid-origin coord sys.
  //   Move x down 1 unit, move y down 1 unit, and flip y so that positive-y
  //   axis points up (as opposed to pointing down in the upper-left-origin
  //   coord sys).
  //   New coord sys is [-1, 1] in both x and y, old coord sys is [0,0] to
  //   [2,2] in both x and y.
  x_trans = x_trans - 1.0f;
  y_trans = - y_trans + 1.0f;

  // Calc z-coord from x and y coords, so can get the (x,y,z) pt that mouse
  //   touches on the virtual sphere of the trackball.
  //   Use sphere eqn x^2 + y^2 + z^2 = 1 for unit sphere.
  //float z2_trans = 1 - x_trans*x_trans - y_trans*y_trans;
  // Slightly bigger sphere
  float z2_trans = 4 - x_trans*x_trans - y_trans*y_trans;
  float z_trans = 0.0;
  if (z2_trans > 0.0)
    z_trans = (float) sqrt (z2_trans);
  else
  {
    z_trans = 0.0f;
    x_trans = (x_trans) / (sqrt (x_trans * x_trans + y_trans * y_trans));
    y_trans = (y_trans) / (sqrt (x_trans * x_trans + y_trans * y_trans));
  }

  curr_pt.setAll (x_trans, y_trans, z_trans);
  curr_pt.norm (curr_pt);

//  if (doAction)
//    calcMousePanPsysBillb (curr_x, curr_y, curr_pt);

  // Save this pos for next mouse motion calculations
  prev_pt_pan_tball.set (0, curr_pt [0]);
  prev_pt_pan_tball.set (1, curr_pt [1]);
  prev_pt_pan_tball.set (2, curr_pt [2]);
  */
}

// For mouse guided pan
void ourWindow::calcMousePan (int curr_x, int curr_y, Vector3& curr_pt)
{
  Vector3 diff = Vector3 ();
  curr_pt.sub (prev_pt_pan, diff);

  // make sure again to discard z. just want xy-pan
  diff.set (2, 0);

  // pan the difference amount btwn this cursor pt and last cursor pt
  Matrix4 transf = Matrix4 ();
  transf.translate (diff[0], diff[1], diff[2]);
  transf.mul (_user_mov_mat, _user_mov_mat);

  // Update picture
  glutPostRedisplay ();
}

void ourWindow::calcMousePanPsysBillb (int curr_x, int curr_y,
  Vector3& curr_pt)
{
  // Use this pt and prev pt on sphere as 2 vectors (as opposed to pts), calc
  //   rotation axis and degree required to rotate sphere from prev pt to curr
  //   pt.
  // Axis = cross prod, radians = acos (dot prod / (mag1 * mag2)).
  Vector3 rot_axis = Vector3 ();
  prev_pt_pan_tball.cross (curr_pt, rot_axis);

  float radians = acos (prev_pt_pan_tball.dot (curr_pt) /
    (prev_pt_pan_tball.len () * curr_pt.len ()));
  
  // particle system billboard update
  if (_psys1)
    _psys1 -> setBillboard (rot_axis, radians);

  // Update picture
  glutPostRedisplay ();
}


void ourWindow::printGLerr ()
{
  //fprintf (stderr, "Error nubmer: %d (want %d) **************** \n",
  //  glGetError (), GL_NO_ERROR);
  GLenum errnum = glGetError ();
  switch (errnum)
  {
    case GL_NO_ERROR:
      fprintf (stderr, "GL_NO_ERROR\n");
      break;
    case GL_INVALID_ENUM:
      fprintf (stderr, "GL_INVALID_ENUM\n");
      break;
    case GL_INVALID_VALUE:
      fprintf (stderr, "GL_INVALID_VALUE\n");
      break;
    case GL_INVALID_OPERATION:
      fprintf (stderr, "GL_INVALID_OPERATION\n");
      break;
    case GL_STACK_OVERFLOW:
      fprintf (stderr, "GL_STACK_OVERFLOW\n");
      break;
    case GL_STACK_UNDERFLOW:
      fprintf (stderr, "GL_STACK_UNDERFLOW\n");
      break;
    case GL_OUT_OF_MEMORY:
      fprintf (stderr, "GL_OUT_OF_MEMORY\n");
      break;
    case GL_TABLE_TOO_LARGE:
      fprintf (stderr, "GL_TABLE_TOO_LARGE\n");
      break;
    default:
      fprintf (stderr, "Some other error...?\n");
      break;
  }
}


// ----------------------------------------------------- Pgm file from hw 2 --


// Culling
// Extract frustum volume info - has to be done every time the frustum changes
//   e.g. camera movement, perspective change
// TODO: call this fn every time cam persp changes, so in trackball??
void ourWindow::calcFrustumPlanes ()
{

  //fprintf (stderr, "in calcFrustumPlanes\n");

  // Plane is described by a normal and a pt on the plane.

  // Find some basic parameters
  //   width and height of near and far planes
  float Hnear = fabs (tan (fov / 2) * near * 2), Wnear = Hnear * ratio;
  float Hfar = fabs (tan (fov / 2) * far * 2), Wfar = Hfar * ratio;

  // view ray goes from camera position (apex of pyramid of frustum) to 
  //   camera's look-at point (in center of near and far planes)
  // Normalize it so can use as direction to add later.
  Vector3 camViewRay = Vector3 ();
  camLookat.sub (camPos, camViewRay);
  camViewRay.norm (camViewRay);

  // Right vector of camera, obtained from cross prod of up and view vecs.
  //   (`.` cross prod finds a 3rd vec perpendicular to the given 2).
  // camRight, camUp, and camViewRay together form the cam's local coords sys
  Vector3 camRight = Vector3 ();
  // Order of crossing matters!
  camViewRay.cross (camUp, camRight);

  
  // Find normal and a pt in each plane (6 total) of the frustum

  Vector3 edge = Vector3 ();

  // near
  // normal points outwards, oppos as view ray, pting back to camPos
  Vector3 norm_near = Vector3 (), pt_near = Vector3 ();
  camViewRay.mul (-1.0, norm_near);
  // near center = camPos + viewRay * nearDist. (nc = p + d * near)
  Vector3 nc = Vector3 ();
  camViewRay.mul (near, nc);
  camPos.add (nc, nc);
  pt_near.setAll (nc[0], nc[1], nc[2]);
  if (CULL_DEBUG)
  {
    fprintf (stderr, "camPos %f %f %f \n", camPos[0], camPos[1], camPos[2]);
    fprintf (stderr, "nc: "); nc.print ();
    fprintf (stderr, "pt_near: "); pt_near.print ();
    fprintf (stderr, "norm_near: "); norm_near.print ();
  }

  // far
  // normal pts outwards, in same dir as cam's view ray
  Vector3 norm_far = Vector3 (), pt_far = Vector3 ();
  norm_far.setAll (camViewRay[0], camViewRay[1], camViewRay[2]);
  // far plane center = camPos + camViewRay * farDist (fc = p + d * far)
  Vector3 fc = Vector3 ();
  camViewRay.mul (far, fc);
  camPos.add (fc, fc);
  pt_far.setAll (fc[0], fc[1], fc[2]);
  if (CULL_DEBUG)
  {
    fprintf (stderr, "fc: "); fc.print ();
    fprintf (stderr, "pt_far: "); pt_far.print ();
  }

  // left
  // edge pt = nc - (right * (Wnear / 2)) - p
  if (CULL_DEBUG) {fprintf (stderr, "camRight vec: "); camRight.print ();}
  camRight.mul (Wnear / 2, edge);
  nc.sub (edge, edge);
  // pt on edge of near plane
  Vector3 pt_left = Vector3 ();
  pt_left.setAll (edge[0], edge[1], edge[2]);
  if (CULL_DEBUG) {fprintf (stderr, "pt_left: "); pt_left.print ();}
  // vector from camPos to the pt
  edge.sub (camPos, edge);
  if (CULL_DEBUG) {fprintf (stderr, "edge vec: "); edge.print ();}
  // normal = up x edge. order matters
  Vector3 norm_left = Vector3 ();
  edge.norm (edge);
  camUp.cross (edge, norm_left);
  // a pt in left plane
  if (CULL_DEBUG) {fprintf (stderr, "norm_left: "); norm_left.print();}

  // right
  // edge pt = nc + (right * (Wnear / 2)) - p
  camRight.mul (Wnear / 2, edge);
  nc.add (edge, edge);
  // pt on right edge of near plane
  Vector3 pt_right = Vector3 ();
  pt_right.setAll (edge[0], edge[1], edge[2]);
  if (CULL_DEBUG) {fprintf (stderr, "pt_right: "); pt_right.print ();}
  // normal = edge x up. order matters (oppo from lighthouse3d `.` their
  //   normals are assumed to point INWARDS! We want them outwards.
  edge.sub (camPos, edge);
  Vector3 norm_right = Vector3 ();
  edge.norm (edge);
  edge.cross (camUp, norm_right);
  if (CULL_DEBUG) {fprintf (stderr, "norm_right: "); norm_right.print ();}

  // top
  // edge pt = nc + (up * (Hnear / 2)) - p
  camUp.mul (Hnear / 2, edge);
  nc.add (edge, edge);
  // pt on top edge of near plane
  Vector3 pt_top = Vector3 ();
  pt_top.setAll (edge[0], edge[1], edge[2]);
  if (CULL_DEBUG) {fprintf (stderr, "pt_top: "); pt_top.print ();}
  // normal = right x edgePt. order matters.
  edge.sub (camPos, edge);
  Vector3 norm_top = Vector3 ();
  edge.norm (edge);
  camRight.cross (edge, norm_top);
  if (CULL_DEBUG) {fprintf (stderr, "norm_top: "); norm_top.print ();}

  // bottom
  // edge pt = nc - (up * (Hnear / 2)) - p
  camUp.mul (Hnear / 2, edge);
  nc.sub (edge, edge);
  // pt on bottom edge of near plane
  Vector3 pt_bott = Vector3 ();
  pt_bott.setAll (edge[0], edge[1], edge[2]);
  if (CULL_DEBUG) {fprintf (stderr, "pt_bott: "); pt_bott.print ();}
  // normal = edgePt x right. order matters
  edge.sub (camPos, edge);
  Vector3 norm_bott = Vector3 ();
  edge.norm (edge);
  edge.cross (camRight, norm_bott);
  if (CULL_DEBUG) {fprintf (stderr, "norm_bott: "); norm_bott.print ();}

  // normalize all the normal vecs so that they're actual normals
  norm_near.norm (norm_near);
  norm_far.norm (norm_far);
  norm_left.norm (norm_left);
  norm_right.norm (norm_right);
  norm_top.norm (norm_top);
  norm_bott.norm (norm_bott);

  _world_tg -> setFrusNear (norm_near, pt_near);
  _world_tg -> setFrusFar (norm_far, pt_far);
  _world_tg -> setFrusLeft (norm_left, pt_left);
  _world_tg -> setFrusRight (norm_right, pt_right);
  _world_tg -> setFrusTop (norm_top, pt_top);
  _world_tg -> setFrusBott (norm_bott, pt_bott);

  
  if (CULL_DEBUG)
    fprintf (stderr,
    "near %f %f %f far   %f %f %f \n"
    "left %f %f %f right %f %f %f \n"
    "top  %f %f %f bott  %f %f %f \n",
    norm_near[0], norm_near[1], norm_near[2],
    norm_far[0], norm_far[1], norm_far[2],
    norm_left[0], norm_left[1], norm_left[2],
    norm_right[0], norm_right[1], norm_right[2],
    norm_top[0], norm_top[1], norm_top[2],
    norm_bott[0], norm_bott[1], norm_bott[2]
    );
  



}


/*
// Obj files code from hw2
// -------------------------------------------------------------- Obj files --

ObjFile::ObjFile ()
{
  Shape ();
} 


// Call routine to load and read .obj file.
// Parameters:
//   transformMat: matrix to store the final transformation 
void ObjFile::loadObj (Matrix4& transformMat)
{
  fprintf (stderr, "Reading obj file %s... ", objFilename);

  // To store min max x y z for scale and translation to fit unit cube window
  float minmax [6];

  // Read an obj file
  ObjReader::readObj (objFilename, nVerts, &verts, &normals, &texcoords,
    nIndices, &indices, minmax);

  fprintf (stderr, "Loaded.\n");

  normalize (minmax, transformMat);
}


// Calculate translation and scale matrices so that the obj model can be
//   centered at (0,0,0) and fits in the unit cube.
void ObjFile::normalize (float * minmax, Matrix4& transformMat)
{
  float min_x = minmax [ObjReader::MIN_X_IDX];
  float max_x = minmax [ObjReader::MAX_X_IDX];
  float min_y = minmax [ObjReader::MIN_Y_IDX];
  float max_y = minmax [ObjReader::MAX_Y_IDX];
  float min_z = minmax [ObjReader::MIN_Z_IDX];
  float max_z = minmax [ObjReader::MAX_Z_IDX];


  // Calc translation matrix for .obj model

  float x_trans = 0, y_trans = 0, z_trans = 0;

  // Translate to make object fit into unit cube
  // Calculate midpoint. If midpoint is not at (0,0,0), translate the inverse
  //   i.e. negate, to make the midpoint at (0,0,0)
  x_trans = - ((max_x + min_x) / 2);
  y_trans = - ((max_y + min_y) / 2);
  z_trans = - ((max_z + min_z) / 2);

  Matrix4 transMat = Matrix4 ();
  transMat.translate (x_trans, y_trans, z_trans);


  // Calc scale matrix for .obj model

  // Min ratio of window size to object size, used for uniform scaling (thus
  //   need min. Else might scale too much if use max)
  float factor = min (ourWindow::width / (float) (max_x - min_x),
    ourWindow::height / (float) (max_y - min_y));

  // Debug
  //fprintf (stderr, "x_width %f y_height %f scaling factor %f",
  //  (float) max_x - min_x, (float) max_y - min_y, factor);

  //factor /= 10;
  //factor = pow (factor, (float) 1/3);
  factor = pow (factor, (float) 1/2);

  Matrix4 scaleMat = Matrix4 ();
  scaleMat.scale (factor, factor, factor);


  scaleMat.mul (transMat, transformMat);
}


// Draw shapes read and stored from the obj file
// Note: texcoords data is currently ignored.
void ObjFile::draw ()
{
  float solidColor [] = {1, 1, 0};

  doDraw (nVerts, verts, nIndices, indices, NULL, solidColor, normals);
}

*/



