//
// Mengzi Zhang
// 24 Sept 2010
// CSE 167 hw 1
//

#ifndef _MATRIX4_H_
#define _MATRIX4_H_

#include <Vector3.h>
#include <Vector4.h>

class Matrix4
{
  protected:
    // matrix elements
    //double m[4][4];
    double m[16];
    
  public:
    // ctors
    Matrix4();
    Matrix4(double, double, double, double, double, double, double, double, double, double, double, double, double, double, double, double);

    // Supplied fns
    // return pointer to matrix elements
    double* getPointer();
    // create identity matrix
    void identity();
    // ret rotation mat about y axis
    void rotateY(double);

    // Mine
    void rotateX (double);
    void rotateZ (double);
    void rotate (double a0, double a1, double a2, double angle);
    void set (int i, int j, double val);
    void set (int idx, double val);
    void setAll (double, double, double, double, double, double, double, double, double, double, double, double, double, double, double, double);
    double get (int i, int j);
    double get (int idx);
    void mul (Matrix4& mat2, Matrix4& res);
    void mul (Vector4& vec4, Vector4& res);
    void mul (Vector3& vec3, Vector3& res);
    double mul_nodehom (Vector3& vec_orig, Vector3& res_fin);
    void premul (Vector4& vec, Vector4& res);
    void premul (Vector3& vec_orig, Vector3& res_fin);
    void translate (double tx, double ty, double tz);
    void scale (double sx, double sy, double sz);
    void transpose (Matrix4& res);

    void inv (Matrix4& res);

    void print ();
};

#endif

