//
// (Mabel) Mengzi Zhang
// 21 Oct 2010
// CSE 167 hw 4
//

#ifndef _LIGHT_H_
#define _LIGHT_H_

#include <GL/glut.h>
#include <leaf.h>
#include <Vector4.h>

class Light : public Leaf
{
  public:
    Light ();
    ~Light () {}

    void enable ();
    void enable (GLenum litNum);
    void disable (GLenum litNum);
    bool toggle (GLenum litNum);
    void updateState (GLenum litNum, bool state);
    void setLitNum (GLenum litNum);

    // Alpha values are ignored until blending is enabled.

    // For all lights
    void setAmbient (GLfloat v1, GLfloat v2, GLfloat v3, GLfloat v4);
    void setDiffuse (GLfloat v1, GLfloat v2, GLfloat v3, GLfloat v4);
    // Set to same value as diffuse light to get realistic effect, `.` specular
    //   highlight on an obj is usually the color of the light in real life.
    void setSpec (GLfloat v1, GLfloat v2, GLfloat v3, GLfloat v4);

    // Make v4 0 if want directional light,
    //   make it 1 if want point light.
    void setPos (GLfloat v1, GLfloat v2, GLfloat v3, GLfloat v4);

    // For spotlight
    void setSpotDir (GLfloat v1, GLfloat v2, GLfloat v3);
    void setSpotExp (GLfloat v);
    void setSpotCut (GLfloat v);

    // For attenuation
    // Setting attenuation uses formula intensity = 1 / c1*k^2 + c2*k + c3
    //   because of the division and extra calcs, using attenuation may
    //   decrease performance.
    void setAttenConst (GLfloat c3);
    void setAttenLin (GLfloat c2);
    void setAttenQuad (GLfloat c1);


    void draw (Matrix4& C);
    void draw_noCull (Matrix4& C) {draw (C);};


  protected:

    GLenum litNum;
    bool isLitOn [8];

    bool toggle_update (int idx, GLenum litNum);

    Vector4 pos;
    Vector3 dir;

};

#endif

