// 
// (Mabel) Mengzi Zhang
// 30 Oct 2010
// CSE 167 hw 5
//
// Motion can be accomplished by changing the transformation matrices of an
//   instance of this class.
//

#ifndef _TRANFORM_GROUP_H_
#define _TRANFORM_GROUP_H_

#include <Matrix4.h>
#include <node.h>
#include <group.h>

class TransformGroup : public Group
{
  public:

    TransformGroup ();
    // Use virtual keyword to make sure the right destructor is called, i.e.
    //   TransformGroup's dtor, not Group (parent)'s detor.
    virtual ~TransformGroup ();

    Matrix4 * getMat ();

    void mulRotate (float x, float y, float z, float a);
    void mulTranslate (float x, float y, float z);

    void setFrusNear (Vector3& n, Vector3& p);
    void setFrusFar (Vector3& n, Vector3& p);
    void setFrusLeft (Vector3& n, Vector3& p);
    void setFrusRight (Vector3& n, Vector3& p);
    void setFrusTop (Vector3& n, Vector3& p);
    void setFrusBott (Vector3& n, Vector3& p);
    //void setFrustumPlanes (Vector3 ** norms, Vector3 ** pts);

    virtual void draw (Matrix4& C);
    virtual void draw_noCull (Matrix4& C);



  protected:

    // Store a transform mat, applied to subtree below this TransGrp node
    Matrix4 mat;


};


//static Vector3 * frus_norms [6];
//static Vector3 * frus_pts [6];

static Vector3 norm_near = Vector3 (), norm_far = Vector3 (),
  norm_top = Vector3 (), norm_bott = Vector3 (),
  norm_left = Vector3 (), norm_right = Vector3 ();
static Vector3 pt_near = Vector3 (), pt_far = Vector3 (),
  pt_top = Vector3 (), pt_bott = Vector3 (),
  pt_left = Vector3 (), pt_right = Vector3 ();

#endif

