// 
// (Mabel) Mengzi Zhang
// 30 Oct 2010
// CSE 167 hw 5
//

#include <group.h>


Group::Group ()
{
  size = 0;
  capacity = 0;
  childList = NULL;
}

Group::~Group ()
{
  if (childList)
    delete childList;
}


// ------------------------------------------------------------- child list --

// Add child into this group
// copy ptr or whatever, like arrayList at Google interview O_O
void Group::addChild (Node * child)
{
  // If (capacity == old size), allocate a larger array. Copy data from orig
  //   array to larger array, then set last elt to new child.
  if (capacity < size + 1)
  {
    // Create new array 1 elt bigger than current array
    capacity = size + 1;
    Node ** newList = new Node * [size+1];

    // Copy all elts in old (current) array to new array
    for (int i = 0; i < size; i++)
      newList [i] = childList [i];
    // Last elt, the new child
    newList [size] = child;

    // Free up mem of old array
    if (childList)
      delete[] childList;

    // Pt to new array
    childList = newList;
  }

  else // capacity >= size + 1, big enough, don't need to reallocate array
  {
    childList [size] = child;
  }

  size ++;
}

// Remove a child from this group
void Group::removeChild (Node * child)
{
  int i = 0;

  // Find index of the child to remove
  for (i = 0; i < size; i++)
    // Ptr comparison to find the child in interest
    if (childList [i] == child)
      break;

  removeChild (i);
}

// Remove ith child from this group
void Group::removeChild (int i)
{
  // Set ith ptr to null to remove it
  childList [i] = 0;

  // Shift all the remaining ptrs 1 element up
  for (int j = i; j < size; j++)
    childList [i] = childList [i+1];

  size --;
  // capacity stays the same. the array has already been allocated
}

// Get ith child in this Group
Node * Group::getChild (int i)
{
  return childList [i];
}


// ---------------------------------------------------------------------------

// Child can call these draw*() fns by choice. TransformGroup has its own `.`
//   it implements culling.

// Draw all geometry, No culling involved
void Group::draw (Matrix4& C)
{
  for (int i = 0; i < size; i ++)
  {
    // Debug. Very helpful, goes through entire hierarchy!
    //fprintf (stderr, "Calling %s.draw()\n", curr_child -> getName());

    childList[i] -> draw (C);
  }
}


// Draw all geometry, No culling involved
void Group::draw_noCull (Matrix4& C)
{
  for (int i = 0; i < size; i ++)
  {
    // Debug. Very helpful, goes through entire hierarchy!
    //fprintf (stderr, "Calling %s.draw_noCull()\n", curr_child -> getName());

    childList[i] -> draw_noCull (C);
  }
}


